<?php
if ( ! class_exists( 'snsanton_Class' ) ) {
	class snsanton_Class {
		public function __construct() {
			// Set cookie theme option
			add_action( 'wp_ajax_sns_setcookies', array($this,'snsanton_setcookies') );
			add_action( 'wp_ajax_nopriv_sns_setcookies', array($this,'snsanton_setcookies') );
			// Reset cookie theme option
			add_action( 'wp_ajax_sns_resetcookies', array($this,'snsanton_resetcookies') );
			add_action( 'wp_ajax_nopriv_sns_resetcookies', array($this,'snsanton_resetcookies') );
		}
		public function snsanton_setcookies(){
			setcookie('snsanton_'.$_POST['key'], $_POST['value'], time()+3600*24*1, '/'); // 1 day
			
		}
	
		public function snsanton_resetcookies(){
			setcookie('snsanton_advance_scss_compile', '', 0, '/');
			//setcookie('snsanton_theme_color', '', 0, '/');
			setcookie('snsanton_use_boxedlayout', '', 0, '/');
			setcookie('snsanton_use_stickmenu', '', 0, '/');
		}
		function snsanton_getStyle($compile = 2, $scss = array('dir' => '', 'name' => ''), $css = array('dir' => '', 'name' => ''), $format = 'scss_formatter_compressed', $variables = array() ) {
			if($css['name'] == '') $css['name'] = $scss['name'];
			$scss_variables = '';
			if($variables) {
				//$css['name'] .= '-';
				foreach($variables as $propety => $value) {
					$scss_variables .= $propety . ':' . $value . ';';
					$css['name'] .= '-'.strtolower(preg_replace('/\W/i', '', $value));
				}
			}
			
			if( $compile == 2 || !file_exists(get_template_directory() . '/assets/css/' . $css['name'] . '.css') )
				$this->snsanton_compileScss($scss, $css, $format, $scss_variables);
			return $css['name'] . '.css';
		}
		function snsanton_compileScss($scss, $css, $format, $scss_variables) {
			// global $wp_filesystem;
			// if (empty($wp_filesystem)) {
			// 	require_once ABSPATH . '/wp-admin/includes/file.php';
			// 	WP_Filesystem();
			// }
			// require "scssphp/scss.inc.php";
			// require "scssphp/compass/compass.inc.php";
			// $sass = new scssc();
			// new scss_compass($sass);
			// $format = ($format == NULL) ? 'scss_formatter_compressed' : $format;
			// $sass->setFormatter($format);
			// $sass->addImportPath($scss['dir']);
			// $string_sass = $scss_variables . $wp_filesystem->get_contents($scss['dir'] . $scss['name'] . '.scss');
			// $string_css = $sass->compile($string_sass);
			// //$string_css = preg_replace('/\/\*[\s\S]*?\*\//', '', $string_css); // remove mutiple comments
			// $wp_filesystem->put_contents(
			// 	$css['dir'] . $css['name'] . '.css',
			// 	$string_css,
			//   	FS_CHMOD_FILE
			// );

			global $wp_filesystem;
			if (empty($wp_filesystem)) {
				require_once ABSPATH . '/wp-admin/includes/file.php';
				WP_Filesystem();
			}
			require "scssphp/scss.inc.php";
			if ( class_exists('ScssPhp\ScssPhp\Compiler') ) {
				$sass = new ScssPhp\ScssPhp\Compiler();
				if ( $format != NULL && $format != "scss_formatter" ){
					if ( $format == "scss_formatter_compressed" ) {
						$format = 'ScssPhp\ScssPhp\Formatter\Compressed';
						
					}elseif( $format == "scss_formatter_nested" ){
						$format = 'ScssPhp\ScssPhp\Formatter\Nested';
					}
					$sass->setFormatter($format);
				}
				
				$sass->addImportPath($scss['dir']);
				$string_sass = $scss_variables . $wp_filesystem->get_contents($scss['dir'] . $scss['name'] . '.scss'); //var_dump($string_sass); die();
				$string_css = $sass->compile($string_sass);
				$wp_filesystem->put_contents(
					$css['dir'] . $css['name'] . '.css',
					$string_css,
				  	FS_CHMOD_FILE
				);
			}
		}
		function snsanton_getOption($param, $default = '', $key = ''){
			global $snsanton_opt;
			$value = '';
			// Get config via theme option
			if($key !== ''){
				if ( isset($snsanton_opt[$param][$key]) && $snsanton_opt[$param][$key] ) $value = $snsanton_opt[$param][$key];
			}else{
				if ( isset($snsanton_opt[$param]) && $snsanton_opt[$param] ) $value = $snsanton_opt[$param];
			}
			
			// Get config via cookie
			if ( isset($_COOKIE['snsanton_'.$param]) && $_COOKIE['snsanton_'.$param] != '' ) {
				$value = $_COOKIE['snsanton_'.$param];
			}
			
			// Get config via page config
			if(is_page()){
				if ( function_exists('rwmb_meta') && rwmb_meta('snsanton_'.$param) ) $value = rwmb_meta('snsanton_'.$param);
			}
			
			if($value || class_exists( 'ReduxFramework' ))
				return $value; 
			// return default value
			return $default;
		}
		function snsanton_css_file(){
			$optimize = '';
			$theme_color = $this->snsanton_getOption('theme_color', '#f89b72');
			
			// Get page meta data
			if ( is_page() && function_exists('rwmb_meta') && rwmb_meta('snsanton_page_themecolor') == 1) {
				$theme_color = rwmb_meta('snsanton_theme_color') != '' ? rwmb_meta('snsanton_theme_color') : $theme_color;
			}
			
			$header_bg_color= $this->snsanton_getOption('header_bg_color', '#ffffff');
			$footer_bg_color= $this->snsanton_getOption('footer_bg_color', '#ffffff'); 
			$footer_bottom_bg_color= $this->snsanton_getOption('footer_bottom_bg_color', '#fafafa'); 
			// Body color
			$body_color = $this->snsanton_getOption('body_font', '#4c5462', 'color');

			$scss_compile = snsanton_themeoption('advance_scss_compile');
			$scss_format = $this->snsanton_getOption('advance_scss_format', 'scss_formatter_compressed');
			
			// Compile scss and get css file name
			$css_file = $this->snsanton_getStyle(
				$scss_compile,
				array('dir' => SNSANTON_THEME_DIR . '/assets/scss/', 'name' => 'theme'),
				array('dir' => SNSANTON_THEME_DIR . '/assets/css/', 'name' => 'theme'),
				$scss_format,
				array(
					'$color1' => $theme_color,
					'$color' => $body_color,
					'$header_bg_color' => $header_bg_color,
					'$footer_bg_color' => $footer_bg_color,
					'$footer_bottom_bg_color' => $footer_bottom_bg_color,
				)
			);
			
			return $css_file;
		}
		
	}
}
?>