<?php
// Sub cats
remove_filter( 'woocommerce_product_loop_start', 'woocommerce_maybe_show_product_subcategories' );
add_action( 'woocommerce_before_main_content', 'snsanton_archive_subcategories', 2);
function snsanton_archive_subcategories(){ ?>
    <ul class="sub-cats">
    <?php
    $display_type = woocommerce_get_loop_display_mode();
    if ( 'subcategories' === $display_type || 'both' === $display_type ) {
        woocommerce_output_product_categories( array(
            'parent_id' => is_product_category() ? get_queried_object_id() : 0,
        ) );
    }
    ?>
    </ul>
    <?php
}
if(class_exists('WooCommerce')){
	class snsanton_Woocommerce{

        public $revsliders = array();

		public static function getInstance(){
			static $_instance;
			if( !$_instance ){
				$_instance = new snsanton_Woocommerce();
			}
			return $_instance;
		}
		public function __construct(){
            global $wpdb;
            $this->revsliders[0] = 'Select a slider';
            if ( ! function_exists( 'is_plugin_active' ) ) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }
            if (is_plugin_active('revslider/revslider.php')) {
                $query = $wpdb->prepare("
                    SELECT * 
                    FROM {$wpdb->prefix}revslider_sliders 
                    ORDER BY %s"
                    , "ASC");
                $get_sliders = $wpdb->get_results($query);
                if($get_sliders) {
                    foreach($get_sliders as $slider) {
                       $this->revsliders[$slider->alias] = $slider->title;
                   }
                }
            }

			// Add Scripts
			add_action('wp_head', array($this, 'snsanton_renderurlajax'), 15);
			add_action( 'wp_enqueue_scripts', array($this,'snsanton_getscripts') );
			// Number product per page
			add_filter( 'loop_shop_columns', array($this, 'snsanton_woo_shop_columns') );
			// Grid cols per row
			add_filter( 'loop_shop_per_page', array($this, 'snsanton_woo_shop_perpage') );
			// Remove each style one by one
			add_filter( 'woocommerce_enqueue_styles', array($this, 'snsanton_dequeue_woostyles') );
			// Set modeview
			add_action( 'wp_ajax_sns_setmodeview', array($this,'snsanton_set_modeview') );
			add_action( 'wp_ajax_nopriv_sns_setmodeview', array($this,'snsanton_set_modeview') );
			// Ajax load more
			add_action('wp_ajax_sns_wooloadmore', array($this, 'snsanton_woo_loadmore'));
			add_action('wp_ajax_nopriv_sns_wooloadmore', array($this, 'snsanton_woo_loadmore'));
			
			// Ajax load more
			add_action('wp_ajax_sns_wootabloadproducts', array($this, 'snsanton_woo_tab_load_products'));
			add_action('wp_ajax_nopriv_sns_wootabloadproducts', array($this, 'snsanton_woo_tab_load_products'));

			remove_action('woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_thumbnail', 10);
            add_action( 'woocommerce_before_shop_loop_item_title', 'snsanton_product_thumbnail', 11 );

            // Add Taxonomy product_cat custom meta fields
            add_action('product_cat_add_form_fields', array(&$this, 'snsanton_product_cat_add_new_meta_field'), 20, 3);
            add_action('product_cat_edit_form_fields', array(&$this, 'snsanton_product_cat_edit_meta_field'), 20, 3);
            // Save extra taxonomy fields callback function
            add_action( 'edit_term', array(&$this,'snsanton_save_product_cat_custom_meta'), 10, 3 );
            add_action( 'created_term', array(&$this,'snsanton_save_product_cat_custom_meta'), 10, 3 );

            // Add Taxonomy product_attributes custom meta fields
            $attribute_taxonomies = wc_get_attribute_taxonomies();
            if ( $attribute_taxonomies ) {
                foreach ( $attribute_taxonomies as $attribute) {
                    add_action( 'pa_' . $attribute->attribute_name . '_add_form_fields', array(&$this, 'snsanton_product_attribute_add_new_meta_field'), 20, 3 );
                    add_action( 'pa_' . $attribute->attribute_name . '_edit_form_fields', array(&$this, 'snsanton_product_attribute_edit_meta_field'), 20, 3);

                    add_action( 'edit_term', array(&$this,'snsanton_product_attribute_save_custom_meta'), 10, 3 );
                    add_action( 'created_term', array(&$this,'snsanton_product_attribute_save_custom_meta'), 10, 3 );
                }
            }
            /*
            * Variable Product
            */
            add_action('wp_head', array(&$this, 'snsanton_variable_product'), 1000);

            // Add product variation select anwhere.
            add_action( 'sns_show_product_loop_variable', array(&$this, 'snsanton_show_product_loop_variable'), 30 );

			remove_action( 'woocommerce_before_shop_loop_item', 'woocommerce_template_loop_product_link_open', 10 );
			remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_product_link_close', 5 );
            // Autocomplete product for sns single product
            if ( class_exists('Vc_Vendor_Woocommerce') ){
                $snsanton_vcwoo = 'Vc_Vendor_Woocommerce';
                add_filter( 'vc_autocomplete_sns_single_product_id_callback', array(&$snsanton_vcwoo, 'productIdAutocompleteSuggester',), 10, 1 ); // Get suggestion(find). Must return an array
                add_filter( 'vc_autocomplete_sns_single_product_id_render', array(&$snsanton_vcwoo, 'productIdAutocompleteRender',), 10, 1 ); // Render exact product. Must return an array (label,value)
                add_filter( 'vc_autocomplete_sns_category_id_callback', array(&$snsanton_vcwoo, 'productIdAutocompleteSuggester',), 10, 1 ); // Get suggestion(find). Must return an array
                add_filter( 'vc_autocomplete_sns_category_id_render', array(&$snsanton_vcwoo, 'productIdAutocompleteRender',), 10, 1 ); // Render exact product. Must return an array (label,value)
            }
		}
		
		public function snsanton_getscripts(){
            global $snsanton_opt;
            $optimize = '.min'; $optimize = '';
            wp_enqueue_script('snsanton-woocommerce', SNSANTON_THEME_URI.'/assets/js/sns-woocommerce'.$optimize.'.js', array('jquery'), '', true);
            if ( class_exists( 'YITH_WCAN_Frontend' ) ) {
                wp_dequeue_script('yith-wcan-script');
                if ( is_product_category() || is_shop() ) {
                    wp_enqueue_script('snsanton-wcan-script', SNSANTON_THEME_URI.'/assets/js/yith-wcan-frontend.js', array('jquery'), '', true);
                    $args = apply_filters( 'yith_wcan_ajax_frontend_classes', array(
                                'container'             => yith_wcan_get_option( 'yith_wcan_ajax_shop_container', '.products' ),
                                'pagination'            => yith_wcan_get_option( 'yith_wcan_ajax_shop_pagination', 'nav.woocommerce-pagination' ),
                                'result_count'          => yith_wcan_get_option( 'yith_wcan_ajax_shop_result_container', '.woocommerce-result-count' ),
                                'wc_price_slider'       => array(
                                   
                                    'min_price' => '.price_slider_amount #min_price',
                                    'max_price' => '.price_slider_amount #max_price',
                                     'wrapper'   => '.price_slider',
                                )
                            )
                    );
                    wp_localize_script( 'snsanton-wcan-script', 'yith_wcan', apply_filters( 'yith-wcan-frontend-args', $args ) );
                }
            }
            if ( is_product() ){
                wp_enqueue_style( 'woocommerce_prettyPhoto_css' );
                wp_enqueue_script( 'prettyPhoto' );
                wp_dequeue_script('prettyPhoto-init');
                if( $snsanton_opt['woo_usecloudzoom'] ) {
                    wp_enqueue_script('elevatezoom-custom', SNSANTON_THEME_URI.'/assets/js/elevatezoom-custom'.$optimize.'.js', array('jquery'), '', true);
                }
            }
        }
		
		public function snsanton_renderurlajax() {
		?>
			<script type="text/javascript">
				var ajaxurl = '<?php echo esc_js( admin_url('admin-ajax.php') ); ?>';
			</script>
			<?php
		}

        public function snsanton_variable_product(){
           $theID = get_the_id();
           $product = wc_get_product( $theID );
           if( !is_product() ){
            return;
           }
            if( $product->get_type() === 'variable' ){
                $attributes = $product->get_attributes();
                 ob_start();?>
                    <script type="text/javascript">
                        var sns_arr_attr = {};
                        <?php foreach ( $attributes as $attribute ) :
                            if ( empty( $attribute['is_visible'] ) || ( $attribute['is_taxonomy'] && ! taxonomy_exists( $attribute['name'] ) ) ) {
                                continue;
                            } else {}
                            
                           $terms = wc_get_product_terms( $product->get_id(), $attribute['name'], array( 'fields' => 'all' ) );
                            
                            $type = '';
                            $key_val = array();
                            $i = 0;
                            foreach ($terms as $term) { $i++;
                                $type = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_type' );
                                $type = ($type == '') ? 'text' : $type;
                                switch ($type) {
                                    case 'color':
                                        $key_val[$term->slug] = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_color' );
                                        break;

                                    case 'image':
                                        $att_image_id = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_image_id' );
                                        $att_image = wp_get_attachment_image_src( $att_image_id, 'snsanton_attribute_pa_images_size' );
                                        $att_image_url = (isset($att_image['0'])) ? $att_image['0'] : '';

                                        $key_val[$term->slug] = $att_image_url;
                                        break;
                                    
                                    default: // type is text
                                        $key_val[$term->slug] = $term->name;
                                        break;
                                }
                            }
                            ?>
                            var attributeName = '<?php echo $attribute['name'] ?>';
                            var data_type = '<?php echo $type; ?>';
                            var key_val = {};
                            <?php foreach ($key_val as $key => $value):?>
                                key_val['<?php echo $key ?>'] = '<?php echo $value ?>';
                            <?php endforeach;?>
                            sns_arr_attr['attribute_' + attributeName] = {'type': data_type, key_val};
                        <?php endforeach; ?>
                    </script>
                <?php
                echo ob_get_clean();
            }
        }

        public function snsanton_show_product_loop_variable(){
            global $product;
            if( $product->get_type() === 'variable' ):
                // Load the template
                wc_get_template( 'variable.php', array(
                    'attributes'           => $product->get_variation_attributes()
                ) );
            endif;
        }
		
		public function snsanton_woo_loadmore(){
			$orderby        = $_POST['order'];
			$number_query   = $_POST['numberquery'];
          //  $show_button   = $_POST['show_button'];
			$start          = $_POST['start'];
			$list_cat       = $_POST['cat'];
			$col            = $_POST['col'];
			$eclass         = $_POST['eclass'];
			$loop = snsanton_woo_query($orderby, $number_query, $list_cat, $start);
             $i = 0;
			while ( $loop->have_posts() ) : $loop->the_post();
            $i++; 
			wc_get_template( 'vc/item-grid.php', array('col' => $col, 'animate' => 1, 'eclass' => $eclass) );
            //  if(($i) % ($col-2) == 0) echo '<div class="clearfix visible-xs"></div>';  
            // if(($i) % ($col-1) == 0) echo '<div class="clearfix visible-sm"></div>';
            // if($i % ($col) == 0) echo '<div class="clearfix visible-md"></div>';
            // if($i % $col == 0) echo '<div class="clearfix visible-lg"></div>';   
			endwhile;
			wp_die();
		}
		
		public function snsanton_woo_tab_load_products(){
			
			$tab_args = array(
					'data_type'		=> $_POST['data_type'],
					'wrap_id'		=> $_POST['wrap_id'],
					'tab_id'		=> $_POST['tab_id'],
					'cat'			=> $_POST['cat'],
					'template'		=> $_POST['template'],
					'orderby'		=> $_POST['orderby'],
					'number_query'	=> $_POST['number_query'],
					'number_display'=> $_POST['number_display'],
                    'number_display_1200'=> $_POST['number_display_1200'],
                    'number_display_992'=> $_POST['number_display_992'],
                    'number_display_768'=> $_POST['number_display_768'],
                    'number_display_480'=> $_POST['number_display_480'],
					'number_limit'	=> $_POST['number_limit'],
					'effect_load'	=> $_POST['effect_load'],
					'col'			=> $_POST['col'],
					'uq'			=> $_POST['uq'],
					'number_load'	=> $_POST['number_load'],
                   // 'show_button'   => $_POST['show_button'],
					'eclass'		=> $_POST['eclass'],
					'animate'		=> 'yes',
				);
			
			wc_get_template( 'vc/template-tab.php', array('tab_args' => $tab_args) );
			wp_die();
		}

		public function snsanton_set_modeview(){
			setcookie('sns_woo_list_modeview', $_POST['mode'] , time()+3600*24*100, '/');
		}
		public function snsanton_woo_shop_columns( $columns ) {
			global $snsanton_opt;
            if(is_product_category()){
                $cat = get_queried_object();
                $snsanton_product_cat_grid_col = snsanton_get_term_byid( $cat->term_id, 'snsanton_product_cat_grid_col' );
                if( $snsanton_product_cat_grid_col != '' )
                    return $snsanton_product_cat_grid_col;
            }
		    return $snsanton_opt['woo_grid_col'];
		}
		public function snsanton_woo_shop_perpage( $columns ) {
			global $snsanton_opt;
             if(is_product_category()){
                $cat = get_queried_object();
                $snsanton_number_perpage = snsanton_get_term_byid( $cat->term_id, 'snsanton_number_perpage' );
                if( $snsanton_number_perpage != '' )
                    return $snsanton_number_perpage;
            }
            
		    return $snsanton_opt['woo_number_perpage'];
		}
		
		public function snsanton_dequeue_woostyles( $enqueue_styles ) {
			unset( $enqueue_styles['woocommerce-general'] );	// Remove the gloss
			unset( $enqueue_styles['woocommerce-layout'] );		// Remove the layout
			unset( $enqueue_styles['woocommerce-smallscreen'] );	// Remove the smallscreen optimisation
			return $enqueue_styles;
		}
         // Add term page
    public function snsanton_product_cat_add_new_meta_field(){
        // This will add the custom meta field  to the add new term page
        $revsliders = $this->revsliders;
        ?>
        <div class="form-field term-snsanton_product_cat_slideshow">
            <label for="snsanton_product_cat_slideshow"><?php esc_html_e( 'Slideshow', 'snsanton' ); ?></label>
            <select name="snsanton_product_cat_slideshow" id="snsanton_product_cat_slideshow">
                <?php
                foreach ($revsliders as $key => $value):?>
                   <option value="<?php  echo $key; ?>"><?php  echo $value; ?></option>
                <?php
                endforeach;
                ?>
            </select>
            <p class="description"><?php esc_html_e( 'Select Slideshow.','snsanton' ); ?></p>
        </div>

        <div class="form-field term-snsanton_product_cat_layout">
            <label for="snsanton_product_cat_layout"><?php esc_html_e( 'Layout', 'snsanton' ); ?></label>
            <select name="snsanton_product_cat_layout" id="snsanton_product_cat_layout">
                <option value=""><?php esc_html_e('Default (Layout of Shop page)', 'snsanton');?></option>
                <option value="m"><?php esc_html_e('Fullwidth', 'snsanton');?></option>
                <option value="l-m"><?php esc_html_e('Left Sidebar', 'snsanton');?></option>
                <option value="m-r"><?php esc_html_e('Right Sidebar', 'snsanton');?></option>
            </select>
            <p class="description"><?php esc_html_e( 'Set the layout fullwidth or has sidebar (Woo Sidebar).','snsanton' ); ?></p>
        </div>

        <div class="form-field term-snsanton_product_cat_grid_col">
            <label for="snsanton_product_cat_grid_col"><?php esc_html_e( 'Grid columns', 'snsanton' ); ?></label>
            <select name="snsanton_product_cat_grid_col" id="snsanton_product_cat_grid_col">
                <option value=""><?php esc_html_e('Default', 'snsanton');?></option>
                <option value="1">1</option>
                <option value="1">2</option>
                <option value="1">3</option>
                <option value="1">4</option>
                <option value="1">6</option>
            </select>
            <p class="description"><?php esc_html_e( 'We are using grid bootstap - 12 cols layout. Default use in Theme Options.','snsanton' ); ?></p>
        </div>
         <div class="form-field term-snsanton_number_perpage">
            <label for="snsanton_number_perpage"><?php esc_html_e( 'Number products per listing page', 'snsanton' ); ?></label>
            <input name="snsanton_number_perpage" id="snsanton_number_perpage" type="text" value="5" size="40">
        </div>
        
        <?php
    }
    // Edit term page
        public function snsanton_product_cat_edit_meta_field($term, $taxonomy){
            $revsliders = $this->revsliders;
            $snsanton_product_cat_slideshow = snsanton_get_term_byid( $term->term_id, 'snsanton_product_cat_slideshow' );

            $snsanton_product_cat_layout = snsanton_get_term_byid( $term->term_id, 'snsanton_product_cat_layout' );
            $snsanton_product_cat_grid_col = snsanton_get_term_byid( $term->term_id, 'snsanton_product_cat_grid_col' );
            $snsanton_number_perpage = snsanton_get_term_byid( $term->term_id, 'snsanton_number_perpage' );
            ?>
            <tr class="form-field snsanton_product_cat_slideshow">
                <th scope="row"><label for="snsanton_product_cat_slideshow"><?php esc_html_e( 'Slideshow', 'snsanton' ); ?></label></th>
                <td>
                    <select name="snsanton_product_cat_slideshow" id="snsanton_product_cat_slideshow">
                        <?php
                        foreach ($revsliders as $key => $value):?>
                           <option value="<?php  echo $key; ?>" <?php selected($snsanton_product_cat_slideshow, $key, true)?>><?php  echo $value; ?></option>
                        <?php
                        endforeach;
                        ?>
                    </select>
                    
                    <p class="description"><?php esc_html_e( 'Select Slideshow.','snsanton' ); ?></p>
                </td>
            </tr>
            
            <tr class="form-field snsanton_product_cat_layout">
                <th scope="row"><label for="snsanton_product_cat_layout"><?php esc_html_e( 'Layout', 'snsanton' ); ?></label></th>
                <td>
                    <select name="snsanton_product_cat_layout" id="snsanton_product_cat_layout">
                        <option value="" <?php selected($snsanton_product_cat_layout, '', true)?>><?php esc_html_e('Default (Layout of Shop page)', 'snsanton');?></option>
                        <option value="m" <?php selected($snsanton_product_cat_layout, 'm', true)?>><?php esc_html_e('Fullwidth', 'snsanton');?></option>
                        <option value="l-m" <?php selected($snsanton_product_cat_layout, 'l-m', true)?>><?php esc_html_e('Left Sidebar', 'snsanton');?></option>
                        <option value="m-r" <?php selected($snsanton_product_cat_layout, 'm-r', true)?>><?php esc_html_e('Right Sidebar', 'snsanton');?></option>
                    </select>
                    
                    <p class="description"><?php esc_html_e( 'Set the layout fullwidth or has sidebar (Woo Sidebar).','snsanton' ); ?></p>
                </td>
            </tr>

            <tr class="form-field snsanton_product_cat_grid_col">
                <th scope="row"><label for="snsanton_product_cat_grid_col"><?php esc_html_e( 'Grid columns', 'snsanton' ); ?></label></th>
                <td>
                    <select name="snsanton_product_cat_grid_col" id="snsanton_product_cat_grid_col">
                        <option value="" <?php selected($snsanton_product_cat_grid_col, '', true)?>><?php esc_html_e('Default', 'snsanton');?></option>
                        <option value="1" <?php selected($snsanton_product_cat_grid_col, '1', true)?>>1</option>
                        <option value="2" <?php selected($snsanton_product_cat_grid_col, '2', true)?>>2</option>
                        <option value="3" <?php selected($snsanton_product_cat_grid_col, '3', true)?>>3</option>
                        <option value="4" <?php selected($snsanton_product_cat_grid_col, '4', true)?>>4</option>
                        <option value="5" <?php selected($snsanton_product_cat_grid_col, '5', true)?>>5</option>
                        <option value="6" <?php selected($snsanton_product_cat_grid_col, '6', true)?>>6</option>
                    </select>
                    
                    <p class="description"><?php esc_html_e( 'We are using grid bootstap - 12 cols layout. Default use in Theme Options.','snsanton' ); ?></p>
                </td>
            </tr>
             <tr class="form-field snsanton_number_perpage">
                <th scope="row"><label for="snsanton_number_perpage"><?php esc_html_e( 'Number products per listing page', 'snsanton' ); ?></label></th>
                <td>
                    <input name="snsanton_number_perpage" id="snsanton_number_perpage" type="text" value="<?php echo $snsanton_number_perpage;?>" size="40">
                </td>
            </tr>
            <?php
        }
        // Save term page
        public function snsanton_save_product_cat_custom_meta($term_id, $tt_id){
            $fields = array(
                'snsanton_product_cat_slideshow',
                'snsanton_product_cat_layout',
                'snsanton_product_cat_grid_col',
                'snsanton_number_perpage',
                'snsanton_woo_onsale_layout',
                'snsanton_woo_onsale_limit'
            );
            
            foreach ($fields as $field){
                if( isset($_POST[$field]) ){
                    $value = !empty($_POST[$field]) ? $_POST[$field] : '';
                    
                    update_woocommerce_term_meta($term_id, $field, $value);
                }
            }
        }

        /*
        *   Add term page for product_attribute
        */
        public function snsanton_product_attribute_add_new_meta_field(){
            // This will add the custom meta field  to the add new term page
            ?>
            <div class="form-field term-snsanton_product_attribute_type">
                <label for="snsanton_product_attribute_type"><?php esc_html_e( 'Type', 'snsanton' ); ?></label>
                <select name="snsanton_product_attribute_type" id="snsanton_product_attribute_type">
                    <option value="text"><?php esc_html_e('Text', 'snsanton');?></option>
                    <option value="color"><?php esc_html_e('Color Picker', 'snsanton');?></option>
                    <option value="image"><?php esc_html_e('Color Image', 'snsanton');?></option>
                </select>
                <p class="description"></p>
            </div>

            <div class="form-field term-snsanton_product_attribute_color">
                <label for="snsanton_product_attribute_color"><?php esc_html_e( 'Color Picker', 'snsanton' ); ?></label>
                <input type="text" class="colorpicker sns-colorpicker" value="" name="snsanton_product_attribute_color"/>
                <p class="description"></p>
            </div>
            
            <div class="form-field term-snsanton_product_attribute_image">
                <label for="snsanton_product_attribute_image"><?php esc_html_e('Color Image', 'snsanton'); ?></label>
                <div id="snsanton_product_attribute_image" style="float: left; margin-right: 10px;">
                    <img src="<?php echo wc_placeholder_img_src(); ?>" width="60px" height="60px">
                </div>
                <div style="line-height: 60px;">
                    <input type="hidden" id="snsanton_product_attribute_image_id" name="snsanton_product_attribute_image_id">
                    <button type="button" class="snscustom_upload_image_button button"><?php esc_html_e('Upload/Add image', 'snsanton'); ?></button>
                    <button type="button" class="snscustom_remove_image_button button" style="display: none;"><?php esc_html_e('Remove image', 'snsanton'); ?></button>
                </div>
                <script type="text/javascript">
    
                    // Only show the "remove image" button when needed
                    if ( ! jQuery( '#snsanton_product_attribute_image' ).val() ) {
                        jQuery( '.snscustom_remove_image_button' ).hide();
                    }
    
                    // Uploading files
                    var snscustom_file_frame;
    
                    jQuery( document ).on( 'click', '.snscustom_upload_image_button', function( event ) {
    
                        event.preventDefault();
    
                        // If the media frame already exists, reopen it.
                        if ( snscustom_file_frame ) {
                            snscustom_file_frame.open();
                            return;
                        }
    
                        // Create the media frame.
                        snscustom_file_frame = wp.media.frames.downloadable_file = wp.media({
                            title: 'Choose an image',
                            button: {
                                text: 'Use image'
                            },
                            multiple: false
                        });
    
                        // When an image is selected, run a callback.
                        snscustom_file_frame.on( 'select', function() {
                            var attachment = snscustom_file_frame.state().get( 'selection' ).first().toJSON();
    
                            jQuery( '#snsanton_product_attribute_image_id' ).val( attachment.id );
                            jQuery( '#snsanton_product_attribute_image' ).find( 'img' ).attr( 'src', attachment.sizes.thumbnail.url );
                            jQuery( '.snscustom_remove_image_button' ).show();
                        });
    
                        // Finally, open the modal.
                        snscustom_file_frame.open();
                    });
    
                    jQuery( document ).on( 'click', '.snscustom_remove_image_button', function() {
                        var $wc_placeholder_img_src = '<?php echo wc_placeholder_img_src(); ?>';
                        jQuery( '#snsanton_product_attribute_image' ).find( 'img' ).attr( 'src', $wc_placeholder_img_src );
                        jQuery( '#snsanton_product_attribute_image_id' ).val( '' );
                        jQuery( '.snscustom_remove_image_button' ).hide();
                        return false;
                    });
    
                </script>
                <div class="clear"></div>
                <p class="description"></p>
            </div>
            <script type="text/javascript">
            jQuery(document).ready(function(){
                jQuery('select[id="snsanton_product_attribute_type"]').each(function(){
                    var $thisSelected = jQuery(this).val();
                    if( $thisSelected == 'color' ){
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeIn(100);
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                    }else if( $thisSelected == 'image' ){
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeIn(100);
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                    }else{
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                    }

                    jQuery(this).on('change', function(){
                        if( this.value == 'color' ){
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeIn(100);
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                        }else if( this.value == 'image' ){
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeIn(100);
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                        }else{
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                        }
                    });
                });
            });
            </script>
            <?php
        }
        // Edit term page
        public function snsanton_product_attribute_edit_meta_field($term, $taxonomy){
            $snsanton_product_attribute_type = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_type' );
            $snsanton_product_attribute_color = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_color' );
            $snsanton_product_attribute_image_id = snsanton_get_term_byid( $term->term_id, 'snsanton_product_attribute_image_id' );
            $image_src = wc_placeholder_img_src(); // WC Thumbnail default
            if($snsanton_product_attribute_image_id !==''){
                $image_src = wp_get_attachment_image_src($snsanton_product_attribute_image_id);
                $image_src = $image_src[0];
            }
            ?>
            
            <tr class="form-field snsanton_product_attribute_type">
                <th scope="row"><label for="snsanton_product_attribute_type"><?php esc_html_e( 'Type', 'snsanton' ); ?></label></th>
                <td>
                    <select name="snsanton_product_attribute_type" id="snsanton_product_attribute_type">
                        <option value="text" <?php selected($snsanton_product_attribute_type, 'text', true)?>><?php esc_html_e('Text', 'snsanton');?></option>
                        <option value="color" <?php selected($snsanton_product_attribute_type, 'color', true)?>><?php esc_html_e('Color Picker', 'snsanton');?></option>
                        <option value="image" <?php selected($snsanton_product_attribute_type, 'image', true)?>><?php esc_html_e('Color Image', 'snsanton');?></option>
                    </select>
                    
                    <p class="description"></p>
                </td>
            </tr>

            <tr class="form-field term-snsanton_product_attribute_color">
                <th scope="row"><label for="snsanton_product_attribute_color"><?php esc_html_e( 'Color Picker', 'snsanton' ); ?></label></th>
                <td>
                    <input type="text" class="colorpicker sns-colorpicker" value="<?php echo esc_attr( $snsanton_product_attribute_color );?>" name="snsanton_product_attribute_color"/>
                    <p class="description"></p>
                </td>
            </tr>

            <tr class="form-field term-snsanton_product_attribute_image">
                <th scope="row" valign="top">
                    <label for="snsanton_product_attribute_image"><?php esc_html_e('Color Image', 'snsanton'); ?></label>
                </th>
                <td>
                    <div id="snsanton_product_attribute_image" style="float: left; margin-right: 10px;">
                        <img src="<?php echo esc_attr( $image_src ) ?>" width="60px" height="60px">
                    </div>
                    <div style="line-height: 60px;">
                        <input type="hidden" id="snsanton_product_attribute_image_id" name="snsanton_product_attribute_image_id" value="<?php echo (int)$snsanton_product_attribute_image_id; ?>">
                        <button type="button" class="snscustom_upload_image_button button"><?php esc_html_e('Upload/Add image', 'snsanton'); ?></button>
                        <button type="button" class="snscustom_remove_image_button button"><?php esc_html_e('Remove image', 'snsanton'); ?></button>
                    </div>
                    <script type="text/javascript">
                        
                        // Only show the "remove image" button when needed
                        if ( '0' === jQuery( '#snsanton_product_attribute_image_id' ).val() ) {
                            jQuery( '.snscustom_remove_image_button' ).hide();
                        }
    
                        // Uploading files
                        var snscustom_file_frame;
    
                        jQuery( document ).on( 'click', '.snscustom_upload_image_button', function( event ) {
    
                            event.preventDefault();
    
                            // If the media frame already exists, reopen it.
                            if ( snscustom_file_frame ) {
                                snscustom_file_frame.open();
                                return;
                            }
    
                            // Create the media frame.
                            snscustom_file_frame = wp.media.frames.downloadable_file = wp.media({
                                title: 'Choose an image',
                                button: {
                                    text: 'Use image'
                                },
                                multiple: false
                            });
    
                            // When an image is selected, run a callback.
                            snscustom_file_frame.on( 'select', function() {
                                var attachment = snscustom_file_frame.state().get( 'selection' ).first().toJSON();
                                jQuery( '#snsanton_product_attribute_image_id' ).val( attachment.id );
                                jQuery( '#snsanton_product_attribute_image' ).find( 'img' ).attr( 'src', attachment.sizes.thumbnail.url );
                                jQuery( '.snscustom_remove_image_button' ).show();
                            });
    
                            // Finally, open the modal.
                            snscustom_file_frame.open();
                        });
    
                        jQuery( document ).on( 'click', '.snscustom_remove_image_button', function() {
                            var $wc_placeholder_img_src = '<?php echo wc_placeholder_img_src(); ?>';
                            jQuery( '#snsanton_product_attribute_image' ).find( 'img' ).attr( 'src', $wc_placeholder_img_src );
                            jQuery( '#snsanton_product_attribute_image_id' ).val( '' );
                            jQuery( '.snscustom_remove_image_button' ).hide();
                            return false;
                        });
        
                    </script>
                    <div class="clear"></div>
                    <p class="description"></p>
                </td>
            </tr>
            <script type="text/javascript">
            jQuery(document).ready(function(){
                jQuery('select[id="snsanton_product_attribute_type"]').each(function(){
                    var $thisSelected = jQuery(this).val();
                    if( $thisSelected == 'color' ){
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeIn(100);
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                    }else if( $thisSelected == 'image' ){
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeIn(100);
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                    }else{
                        jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                        jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                    }

                    jQuery(this).on('change', function(){
                        if( this.value == 'color' ){
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeIn(100);
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                        }else if( this.value == 'image' ){
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeIn(100);
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                        }else{
                            jQuery('.term-snsanton_product_attribute_color').stop(true, true).fadeOut(0);
                            jQuery('.term-snsanton_product_attribute_image').stop(true, true).fadeOut(0);
                        }
                    });
                });
            });
            </script>
            <?php
        }
        // Save term page
        public function snsanton_product_attribute_save_custom_meta($term_id, $tt_id, $taxonomy){
            $fields = array(
                'snsanton_product_attribute_type',
                'snsanton_product_attribute_color',
                'snsanton_product_attribute_image_id'
            );
            
            foreach ($fields as $field){
                if( isset($_POST[$field]) ){
                    $value = !empty($_POST[$field]) ? $_POST[$field] : '';
                    
                    update_woocommerce_term_meta($term_id, $field, $value);
                }
            }
        }
		
	}

	snsanton_Woocommerce::getInstance();
    function snsanton_cart_url(){
        global $woocommerce;
        return esc_url( wc_get_cart_url() );
    }
    
    function snsanton_cart_total(){
        global $woocommerce;
        return $woocommerce->cart->get_cart_total();
    }
    // Re-render rating
    add_filter( 'woocommerce_product_get_rating_html', 'snsanton_get_rating_html', 100, 2 );
    function snsanton_get_rating_html(){
        global $woocommerce, $product;
        if( $product && $product->get_average_rating() ) $rating = $product->get_average_rating();
        if( isset($rating) && $rating > 0){
        	$rating_html  = '<div class="star-rating" title="' . sprintf( esc_html__( 'Rated %s out of 5', 'snsanton' ), $rating ) . '">';
    		$rating_html .= '<span class="value" data-width="' . ( ( $rating / 5 ) * 100 ) . '%"><strong class="rating">' . $rating . '</strong> ' . esc_html__( 'out of 5', 'snsanton' ) . '</span>';
        }else{
        	$rating_html  = '<div class="star-rating">';
        }
    	$rating_html .= '</div>';
    	return $rating_html;
    }

    // Set template view mode
    function snsanton_woo_modeview() {
    	global $snsanton_opt;
    	wc_get_template( 'loop/modeview.php', array('modeview' => $snsanton_opt['woo_list_modeview']) );
    }
    // Override quickview
    function snsanton_woo_images_quickview() {
    	wc_get_template( 'single-product/product-image-quickview.php' );
    }

    function snsanton_woo_query($type, $post_per_page=-1, $cat='', $offset=0, $paged=1){
        global $woocommerce;
        $args = array(
            'post_type' => 'product',
            'posts_per_page' => $post_per_page,
            'post_status' => 'publish',
        	'offset'            => $offset,
            'paged' => $paged
        );
        switch ($type) {
             case 'best_selling':
                $args['meta_key']='total_sales';
                $args['orderby']='meta_value_num';
                $args['ignore_sticky_posts']   = 1;
                $args['meta_query'] = array();
                $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
                $args['meta_query'][] = $woocommerce->query->visibility_meta_query();
                break;
            case 'featured_product':
                $args['ignore_sticky_posts']=1;
                $args['meta_query'] = array();
                $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
                $args['meta_query'][] = $woocommerce->query->visibility_meta_query();
                $args['post__in'] = wc_get_featured_product_ids();
                break;
            case 'top_rate':
                $args['meta_key'] = '_wc_average_rating';
                $args['orderby']  = array(
                    'meta_value_num' => 'DESC',
                    'ID'             => 'ASC',
                );
                break;
            case 'recent':
                $args['meta_query'] = array();
                $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
                break;
            case 'on_sale':
                $args['meta_query'] = array();
                $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
                $args['meta_query'][] = $woocommerce->query->visibility_meta_query();
                $args['post__in'] = wc_get_product_ids_on_sale();
                break;
            case 'recent_review':
                if($post_per_page == -1) $_limit = 4;
                else $_limit = $post_per_page;
                global $wpdb;
                $query = $wpdb->prepare( "
                    SELECT c.comment_post_ID 
                    FROM {$wpdb->prefix}posts p, {$wpdb->prefix}comments c 
                    WHERE p.ID = c.comment_post_ID AND c.comment_approved > %d 
                    AND p.post_type = %s AND p.post_status = %s
                    AND p.comment_count > %d ORDER BY c.comment_date ASC" ,
                    0, 'product', 'publish', 0 );
                $results = $wpdb->get_results($query, OBJECT);
                $_pids = array();
                foreach ($results as $re) {
                    if(!in_array($re->comment_post_ID, $_pids))
                        $_pids[] = $re->comment_post_ID;
                    if(count($_pids) == $_limit)
                        break;
                }

                $args['meta_query'] = array();
                $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
                $args['meta_query'][] = $woocommerce->query->visibility_meta_query();
                $args['post__in'] = $_pids;
                break;
        }

        if($cat!=''){
            $args['product_cat']= $cat;
        }

        return new WP_Query($args);
    }
    add_action('woocommerce_single_product_summary', 'snsanton_woo_countdown', 12);
    function snsanton_woo_countdown(){ 
       // Get the Sale Price Date To of the product

        $sale_price_dates_to    = ( $date = get_post_meta( get_the_ID(), '_sale_price_dates_to', true ) ) ? date_i18n( 'Y/m/d', $date ) : '';      
        if(!empty($sale_price_dates_to)):
        wp_enqueue_script('countdown');
        ?>
        
        <div class="item-slider-countdown">
            <p><?php esc_html_e('Countdown time discount', 'snsanton');?></p>
            <div class="sns_sale_clock">
                <div><div class="day"></div><?php esc_html_e('D', 'snsanton');?></div>
                <div><div class="hours"></div><?php esc_html_e('H', 'snsanton');?></div>
                <div><div class="minutes"></div><?php esc_html_e('M', 'snsanton');?></div>
                <div><div class="seconds"></div><?php esc_html_e('S', 'snsanton');?></div>
            </div>
            <script type="text/javascript">
                jQuery(document).ready(function($){
                    $('#product-<?php the_ID(); ?> .sns_sale_clock').countdown('<?php echo $sale_price_dates_to; ?>', function(event){
                        $(this).find('.day').html(event.strftime('%D'));
                        $(this).find('.hours').html(event.strftime('%H'));
                        $(this).find('.minutes').html(event.strftime('%M'));
                        $(this).find('.seconds').html(event.strftime('%S'));
                    });
                });

            </script>
        </div>
        <?php endif;  
    }
    //
    add_action('woocommerce_single_product_summary', 'snsanton_woo_addthis', 22);
    function snsanton_woo_addthis(){
        global $snsanton_opt;
        $html = '';
        if ( $snsanton_opt['woo_sharebox'] == 1 ) {
            $html .= '
            <script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-5642b62b432840c2"></script>
            <div class="addthis_toolbox addthis_inline_share_toolbox_4lie"></div>
            ';
        }
        echo wp_kses($html, array(
                                'div' => array(
                                    'class' => array(),
                                ),
                                'a' => array(
                                    'href' => array(),
                                    'class' => array(),
                                    'fb:like:layout' => array()
                                ),
                                'script' => array(
                                    'type' => array(),
                                    'src' => array()
                                ),
                            ) );
    }
  //  add_action( 'woocommerce_archive_description', 'snsanton_woo_category_image', 2 );
    function snsanton_woo_category_image() {
        if ( is_product_category() ){
            global $wp_query;
            $cat = $wp_query->get_queried_object();
           
            $thumbnail_id = snsanton_get_term_byid( $cat->term_id, 'thumbnail_id', true );
            
            $image = wp_get_attachment_image_src($thumbnail_id, 'full');
            $image = isset($image[0]) ? $image[0] : '';
            if ( $image ) {
                echo '<p class="cate-img"><img src="' . esc_url($image) . '" alt="" /></p>';
            }
        }
    }

    // Override thumbnail
    function snsanton_post_thumbnail_html($html, $post_id, $post_thumbnail_id, $size, $attr) {
        if(snsanton_themeoption('woo_uselazyload') == 1){
            $id = get_post_thumbnail_id();
            $src = wp_get_attachment_image_src($id, $size);
            $alt = get_the_title($id);
            $class = ( isset($attr['class']) ) ? $attr['class'] : '';
            if (strpos($class, 'lazy') !== false) {
                $html = '<img src="'.SNSANTON_THEME_URI.'/assets/img/prod_loading.gif" alt="'.$alt.'" data-original="' . $src[0] . '" class="' . $class . '" />';
            }
        }
        return $html;
    }
    add_filter('post_thumbnail_html', 'snsanton_post_thumbnail_html', 99, 5);
    function snsanton_product_thumbnail(){
        global $post;
        $size = 'shop_catalog'; // echo '<pre>'; var_dump(get_the_post_thumbnail( $post->ID, 'woocommerce_thumbnail' )); echo '</pre>';
        if ( has_post_thumbnail() ) {
            if( snsanton_themeoption('woo_uselazyload') == 1 ){
                echo get_the_post_thumbnail( $post->ID, $size, array('class' => "lazy attachment-$size") );
            }else{
                echo get_the_post_thumbnail( $post->ID, $size );
            }
        } elseif ( wc_placeholder_img_src() ) {
            echo wc_placeholder_img( $size );
        }
    }
    
    function snsanton_get_woocommerce_categories(){
    	$args = array(
    		'taxonomy' => 'product_cat'
    	);
    	 return get_categories($args);
    }

    add_action( 'woocommerce_archive_description', 'sns_product_category_description', 11 );
    function sns_product_category_description(){
        if(is_product_category()){
            $cate = get_queried_object();
            $snsanton_product_cat_slideshow = snsanton_get_term_byid( $cate->term_id, 'snsanton_product_cat_slideshow' );
            if( !empty($snsanton_product_cat_slideshow) ): ?>
                <div class="sns_product_category_slideshow" class="wrap">
                    <?php
                        echo do_shortcode('[rev_slider '.esc_attr($snsanton_product_cat_slideshow).' ]');
                    ?>
                </div>
            <?php
           endif;
        }
    }
    add_filter( 'woocommerce_product_tabs', 'snsanton_woo_rename_tabs', 98 );
    function snsanton_woo_rename_tabs( $tabs ) {
        if ( isset($tabs['description']) ) {
            $tabs['description']['title'] = esc_html__( 'Description', 'snsanton' );
        }
        if ( isset($tabs['additional_information']) ) {
            $tabs['additional_information']['title'] = esc_html__( 'Additional','snsanton' );   // Rename the additional information tab
        }
        return $tabs;
    }
    add_action('woocommerce_after_cart', 'snsanton_woo_jsqty', 10);
    function snsanton_woo_jsqty(){
        $html = '';
        ob_start();
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function($){
                $('.qty-decrease, .qty-increase').click(function(){
                    $( 'div.woocommerce > form input[name="update_cart"]' ).prop( 'disabled', false );
                });
            });
        </script>
        <?php
        $html .= ob_get_clean();
        echo $html;
    }
}

?>