<?php
$vc_add_css_animation = array(
	'type' => 'dropdown',
	'heading' => esc_html__( 'CSS Animation', 'snsanton' ),
	'param_name' => 'css_animation',
	'admin_label' => true,
	'value' => array(
		esc_html__( 'No', 'snsanton' ) => '',
		esc_html__( 'Top to bottom', 'snsanton' ) => 'top-to-bottom',
		esc_html__( 'Bottom to top', 'snsanton' ) => 'bottom-to-top',
		esc_html__( 'Left to right', 'snsanton' ) => 'left-to-right',
		esc_html__( 'Right to left', 'snsanton' ) => 'right-to-left',
		esc_html__( 'Appear from center', 'snsanton' ) => 'appear'
	),
	'description' => esc_html__( 'Select type of animation for element to be animated when it "enters" the browsers viewport (Note: works only in modern browsers).', 'snsanton' )
);
$sns_extra_class =array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'snsanton'),
			"param_name" => "extra_class"
		);

global $wpdb;
// Get category name
$sql = $wpdb->prepare( "
	SELECT a.name,a.slug,a.term_id 
	FROM {$wpdb->terms} a JOIN  {$wpdb->term_taxonomy} b ON (a.term_id= b.term_id ) 
	WHERE b.count> %d and b.taxonomy = %s",
	0,'category' );
$results = $wpdb->get_results($sql);
$cat_value = array();
foreach ($results as $cat) {
	$cat_value[$cat->name] = $cat->slug;
}

// BEGIN: Shortcodes for Woo
if(class_exists('WooCommerce')){
	// Get woo category name
	$sql = $wpdb->prepare( "
		SELECT a.name,a.slug,a.term_id 
		FROM {$wpdb->terms} a JOIN  {$wpdb->term_taxonomy} b ON (a.term_id= b.term_id ) 
		WHERE b.count> %d and b.taxonomy = %s",
		0,'product_cat' );
	$results = $wpdb->get_results($sql);
	$woocat_value = array();
	//$woocat_value[esc_html__('--Select--', 'snsanton')] = '';
	foreach ($results as $cat) {
		$woocat_value[$cat->name] = $cat->slug;
	}

	function sns_woo_get_product_list($product_type = false){
		global $woocommerce;
	    $product_list =  array();
	    $product_list[esc_html__('--Select--', 'snsanton')] = '';

	    $args = array(
	        'posts_per_page'     => -1,
	        'post_status'          => 'publish',
	        'post_type'          => 'product',
	        'order'              => 'DESC',
	    );

	    switch ($product_type) {
	    	case 'on_sale':
	    		$args['meta_query'] = array();
		        $args['meta_query'][] = $woocommerce->query->stock_status_meta_query();
		        $args['meta_query'][] = $woocommerce->query->visibility_meta_query();
		        $args['post__in'] = wc_get_product_ids_on_sale();
	    		break;
	    	case 'variable':

	    		break;
	    	default:
	    		break;
	    }

	    $products = get_posts( $args );

	    foreach ($products as $product) {
	    	if($product_type == 'variable'){
	    		$get_product = new WC_Product($product->ID);
	    		if( $get_product->is_type('variable') ){
	    			$product_list[$product->post_title] = $product->ID;
	    		}
	    	}else{
	    		$product_list[$product->post_title] = $product->ID;
	    	}
	    }

	    return $product_list;
	}

	$product_list = sns_woo_get_product_list(false);
	$product_onsale = sns_woo_get_product_list('on_sale');

	/*
	 * Product list
	 */
	// $params_script = SNSANTON_THEME_URI . '/admin/assets/js/params.js';
	// vc_add_shortcode_param('sns_woo_products', 'sns_woo_settings_products', $params_script);
	// function sns_woo_settings_products( $settings,  $value, $dependency=''){
	//     $args = array(
	//         'posts_per_page'     => -1,
	//         'post_status'          => 'publish',
	//         'post_type'          => 'product',
	//         'order'              => 'DESC',
	//     );
	//      $products = get_posts( $args );


	// 	$product_ids = explode(',', $value);

	// 	$output = '<select '.$dependency.' id="'.$settings['param_name'].'" multiple="multiple" class="sns-woo-select chosen_select_nostd">';
	// 	$output .= '<option value="">'. esc_html__('-- Select -- ', 'snsanton') . '</option>';
	// 	if( !empty($products) ){
	// 		foreach ($products as $product){
	// 			//var_dump($products);
	// 			$output .= '<option value="'. esc_attr($product->ID) .'"' . selected( in_array($product->ID, $product_ids), true, false ) . '>' . esc_html( $product->post_title ) . '</option>';
	// 		}
	// 	}
	// 	$output .= '</select>';
	// 	$output .= '<input type="hidden" id="'.$settings['param_name'].'" class="wpb_vc_param_value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'"/>';
		
	// 	return $output;
	// }


	/*
	 * SNS create new param type
	 */
	// $params_script = SNSANTON_THEME_URI . '/admin/assets/js/params.js';

	// vc_add_shortcode_param('sns_woo_categories', 'sns_woo_settings_categories', $params_script);
	// function sns_woo_settings_categories( $settings,  $value, $dependency=''){
	// 	$catgory_ids = explode(',', $value);
	// 	$args = array(
	// 		'orderby' => 'name',
	// 		'hide_empty' => 0,
	// 	);
	// 	$categories = get_terms('product_cat', $args);
	// 	$output = '<select '.$dependency.' id="'.$settings['param_name'].'" multiple="multiple" class="sns-woo-select chosen_select_nostd">';
	// 	$output .= '<option value="">'. esc_html__('-- Select -- ', 'snsanton') . '</option>';
	// 	if( !empty($categories) ){
	// 		foreach ($categories as $cat){
	// 			$output .= '<option value="'. esc_attr($cat->slug) .'"' . selected( in_array($cat->slug, $catgory_ids), true, false ) . '>' . esc_html( $cat->name ) . '</option>';
	// 		}
	// 	}
	// 	$output .= '</select>';
	// 	$output .= '<input type="hidden" id="'.$settings['param_name'].'" class="wpb_vc_param_value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'"/>';
		
	// 	return $output;
	// }
	class WPBakeryShortCode_SNS_Products extends WPBakeryShortCode {}

	vc_map( array(
		"name" => esc_html__("SNS Products",'snsanton'),
		"base" => "sns_products",
		"icon" => "sns_icon_products",
		"class" => "sns_products",
		"category" => esc_html__("SNS WooCommerce",'snsanton'),
		"description" => esc_html__( "WooCommerce products",'snsanton' ),
		"params" => array(
			array(
				"type" => "textfield",
				"class" => "",
				"value" => "",		
				"heading" => esc_html__("Prefix", 'snsanton'),
				"param_name" => "prefix" 
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Title",'snsanton'),
				"param_name" => "title",
				"admin_label" => true,
				"value" =>  esc_html__("New Products", 'snsanton'),
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Header style",'snsanton'),
				"param_name" => "header_style",
				"value" => array(
					esc_html__('Style1', 'snsanton') => "style1",
					esc_html__('Style2', 'snsanton') => "style2",
				),
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Template",'snsanton'),
				"param_name" => "template",
				"admin_label" => true,
				"value" => array(
					esc_html__("Carousel",'snsanton') => '1',
					esc_html__("List",'snsanton') => '2',
					esc_html__("Products Countdown",'snsanton') => '3',
				),
				"description" => esc_html__("Select template.", 'snsanton')
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Time Countdown",'snsanton'),
				"param_name" => "countdown",
				"description" => esc_html__("Y/m/d. EX: 2017/01/20", 'snsanton'),
				"value" => '',
				'dependency' => array(
					'element' => 'template',
					'value' => '3',
				),
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"value" => $woocat_value,
				"heading" => esc_html__("Select Category",'snsanton'),
				"param_name" => "category",
				"dependency" => array("element" => "template" , "value" => array("3") ),
				"description" => ""
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Type",'snsanton'),
				"param_name" => "type",
				"value" => array(
					esc_html__('Latest Products', 'snsanton') => "recent",
					esc_html__('BestSeller Products', 'snsanton') => "best_selling",
					esc_html__('Top Rated Products', 'snsanton') => "top_rate",
					esc_html__('Special Products', 'snsanton') => "on_sale",
					esc_html__('Featured Products', 'snsanton') => "featured_product",
					esc_html__('Recent Review', 'snsanton') => "recent_review",
				),
				"dependency" => array("element" => "template" , "value" => "1","2" ),
				"description" => ""
			),
			
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Show Count Sale",'snsanton'),
				"param_name" => "show_countdown",
				"value" => array(
					esc_html__("Yes",'snsanton') => 'yes',
					esc_html__("No",'snsanton') => 'no',
				),
				'dependency' => array(
					'element' => 'template',
					'value' => '1',
				),
			),
			
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen width > 480px","snsanton"),
				"param_name" => "number_display_480",
				"dependency" => array("element" => "template" , "value" => "1" ),
				"value" => "2"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 768px","snsanton"),
				"param_name" => "number_display_768",
				"dependency" => array("element" => "template" , "value" => "1" ),
				"value" => "3"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 992px","snsanton"),
				"param_name" => "number_display_992",
				"dependency" => array("element" => "template" , "value" => "1" ),
				"value" => "3"
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 1200px","snsanton"),
				"param_name" => "number_display_1200",
				"dependency" => array("element" => "template" , "value" => "1" ),
				"value" => "4"
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 1600px","snsanton"),
				"param_name" => "number_display_1600",
				"dependency" => array("element" => "template" , "value" => "1" ),
				"value" => "4"
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number limit",'snsanton'),
				"param_name" => "number_limit",
				"value" => "10",
			),
			$vc_add_css_animation,
			$sns_extra_class,
			
		)
	) );

	class WPBakeryShortCode_SNS_Product_Tabs extends WPBakeryShortCode {
		public function snsanton_getListTabTitle(){
			$this->atts = vc_map_get_attributes( $this->getShortcode(), $this->atts );
			$array_tab = array();
			if ( $this->atts['tab_types'] == 'category' ) :
				if( empty($this->atts['list_cat']) ) :
					$array_tab = $this->snsanton_getCats();
				else :
					$array_tab = explode(',', $this->atts['list_cat']);
				endif;
				//var_dump($array_tab);
			else :
				$array_tab = explode(',', $this->atts['list_orderby']);
			endif;
			foreach ($array_tab as $tab) {
				if ( isset($this->atts['cat_thumbnail']) ) {
					$list_tab[$tab] = $this->snsanton_tabTitle($tab, $this->atts['tab_types'], $this->atts['cat_thumbnail']);
				}else{
					$list_tab[$tab] = $this->snsanton_tabTitle($tab, $this->atts['tab_types'], '');
				}
			}
			return $list_tab;
		}

		public function snsanton_tabTitle($tab, $tab_types,$show_cat_thumbnail){
			if( $tab_types == 'category' ){
				$cat = get_term_by('slug', $tab, 'product_cat');
				
				$image = '';
				if( $show_cat_thumbnail == 'show' ){
					$thumbnail_id = snsanton_get_term_byid($cat->term_id, 'thumbnail_id', true);
					if($thumbnail_id == '')
						$thumbnail_id = snsanton_get_term_byid($cat->term_id, 'snscustom_product_cat_thumbnail_id', true);
						
					$cat_thumb = wp_get_attachment_image_src($thumbnail_id, 'snsanton_product_tabs_thumbnail');

					$image = isset($cat_thumb[0]) ? $cat_thumb[0] : wc_placeholder_img_src();
				}
				return array('name'=>str_replace(' ', '_', $tab),'title'=>$cat->name,'id'=>$cat->term_id,'short_title'=>$cat->name,'thumbnail' => $image);
			}else{
				switch ($tab) {
					case 'recent':
						return array('name'=>$tab,'title'=>esc_html__('New Product','snsanton'),'short_title'=>esc_html__('New Product','snsanton'));
					case 'featured_product':
						return array('name'=>$tab,'title'=>esc_html__('Featured Products','snsanton'),'short_title'=>esc_html__('Featured Products','snsanton'));
					case 'top_rate':
						return array('name'=>$tab,'title'=> esc_html__('Top Rated Products','snsanton'),'short_title'=>esc_html__('Top Rated', 'snsanton'));
					case 'best_selling':
						return array('name'=>$tab,'title'=>esc_html__('BestSeller Products','snsanton'),'short_title'=>esc_html__('Best Seller','snsanton'));
					case 'on_sale':
						return array('name'=>$tab,'title'=>esc_html__('Special Products','snsanton'),'short_title'=>esc_html__('Special Products','snsanton'));
				}
			}
		}
		public function snsanton_getCats(){
			$cats = get_terms('product_cat');
			$arr = array();
			foreach ($cats as $cat) {
				$arr[] = $cat->slug;
			}
			return $arr;
		}
	}

	vc_map( array(
		"name" => esc_html__("SNS Product Tabs",'snsanton'),
		"base" => "sns_product_tabs",
		"icon" => "sns_icon_product_tabs",
		"class" => "sns_product_tabs",
		"category" => esc_html__("SNS WooCommerce",'snsanton'),
		"description" => esc_html__( "WooCommerce product tabs", 'snsanton' ),
		"params" => array(
			array(
				"type" => "textfield",
				"class" => "",
				"value" => "",		
				"heading" => esc_html__("Prefix", 'snsanton'),
				"param_name" => "prefix" 
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Title",'snsanton'),
				"param_name" => "title",
				"admin_label" => true,
				"value" => esc_html__("New Products",'snsanton'),
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Template",'snsanton'),
				"param_name" => "template",
				"value" => array(
					esc_html__("Grid",'snsanton') => "grid",
					esc_html__("Carousel",'snsanton') =>  "carousel"
				),
				"description" => ""
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Navigation tabs",'snsanton'),
				"param_name" => "align_header",
				"value" => array(
					esc_html__('Style1', 'snsanton') => "style1",
					esc_html__('Style2', 'snsanton') => "style2",
					esc_html__('Style3', 'snsanton') => "style3",
					esc_html__('Style4', 'snsanton') => "style4",
				),
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Tab types",'snsanton'),
				"param_name" => "tab_types",
				"value" => array(
					esc_html__('Categories', 'snsanton') => "category",
					esc_html__('Order By', 'snsanton') =>  "orderby"
				),
				"description" => ""
			),
			array(
				"type" => "checkbox",
				"class" => "",
				"value" => $woocat_value,
				"heading" => esc_html__("Select Category",'snsanton'),
				"param_name" => "list_cat",
				"description" => ""
			),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Order By for all tab",'snsanton'),
				"param_name" => "orderby",
				"value" => array(
					esc_html__('New Product', 'snsanton') => "recent",
					esc_html__('BestSeller Products', 'snsanton') => "best_selling",
					esc_html__('Top Rated Products', 'snsanton') => "top_rate",
					esc_html__('Special Products', 'snsanton') => "on_sale",
					esc_html__('Featured Products', 'snsanton') => "featured_product",
					esc_html__('Recent Review', 'snsanton') => "recent_review",
				),

				"dependency" => array("element" => "tab_types" , "value" => "category" ),
				"description" => ""
			),
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Select Order By",'snsanton'),
				"param_name" => "list_orderby",
				"value" => array(
					esc_html__('New Product', 'snsanton') => "recent",
					esc_html__('BestSeller Products', 'snsanton') => "best_selling",
					esc_html__('Top Rated Products', 'snsanton') => "top_rate",
					esc_html__('Special Products', 'snsanton') => "on_sale",
					esc_html__('Featured Products', 'snsanton') => "featured_product",
					esc_html__('Recent Review', 'snsanton') => "recent_review",
				),
				"dependency" => array("element" => "tab_types" , "value" => "orderby" ),
				"description" => ""
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Row",'snsanton'),
				"param_name" => "row",
				"dependency" => array("element" => "template" , "value" => "grid" ),
				"value" => "2"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Column per Row",'snsanton'),
				"param_name" => "col",
				"dependency" => array("element" => "template" , "value" => "grid" ),
				"value" => "4"
			),
			// array(
			// 	"type" => "dropdown",
			// 	"class" => "",
			// 	"heading" => esc_html__("Show Load more button",'snsanton'),
			// 	"param_name" => "show_button",	
			// 	"value" => array(
			// 		esc_html__("Yes",'snsanton') => '1',
			// 		esc_html__("No",'snsanton') =>  '2',
			// 	),	
			// 	"dependency" => array("element" => "template" , "value" => "grid"),		
			// ),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Number product with each click to Load more button",'snsanton'),
				"param_name" => "number_load",
				"dependency" => array( "element" => "template" , "value" => "grid" ),
				"value" => "4"
			),
			array(
				"type" => "checkbox",
				"value" => true,
				"class" => "",
				"heading" => esc_html__("Hidden item box",'snsanton'),
				"param_name" => "hidde_item_box"	
			),

			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Effect for product when click to Load more button",'snsanton'),
				"param_name" => "effect_load",
				"value" => array(
					esc_html__('zoomOut', 'snsanton') => "zoomOut",
					esc_html__('zoomIn', 'snsanton') => "zoomIn",
					esc_html__('pageRight', 'snsanton') => "pageRight",
					esc_html__('pageLeft', 'snsanton') => "pageLeft",
					esc_html__('pageTop', 'snsanton') => "pageTop",
					esc_html__('pageBottom', 'snsanton') => "pageBottom",
					esc_html__('starwars', 'snsanton') => "starwars",
					esc_html__('slideBottom', 'snsanton') => "slideBottom",
					esc_html__('slideLeft', 'snsanton') => "slideLeft",
					esc_html__('slideRight', 'snsanton') => "slideRight",
					esc_html__('bounceIn', 'snsanton') => "bounceIn",
				),
				"dependency" => array("element" => "template" , "value" => "grid" ),
				"description" => ""
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number limit",'snsanton'),
				"param_name" => "number_limit",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "10"
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen width > 480px","snsanton"),
				"param_name" => "number_display_480",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "2"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 768px","snsanton"),
				"param_name" => "number_display_768",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "3"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 992px","snsanton"),
				"param_name" => "number_display_992",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "3"
			),

			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 1200px","snsanton"),
				"param_name" => "number_display_1200",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "4"
			),
			array(
				"type" => "textfield",
				"class" => "",
				"heading" => esc_html__("Product number display screen > 1600px","snsanton"),
				"param_name" => "number_display_1600",
				"dependency" => array("element" => "template" , "value" => "carousel" ),
				"value" => "4"
			),

			$vc_add_css_animation,
			$sns_extra_class,
			
		)
	) );

	class WPBakeryShortCode_SNS_Onsale_Product extends WPBakeryShortCode {}
	vc_map( array(
			"name" => esc_html__("SNS On sale Product",'snsanton'),
			"base" => "sns_onsale_product",
			"icon" => "sns_icon_onsale_product",
			"class" => "sns_onsale_product",
			"category" => esc_html__("SNS WooCommerce",'snsanton'),
			"description" => esc_html__( "show onsale product", 'snsanton' ),
			"params" => array(
					// array(
				 //      "type" => "attach_image",
				 //      "heading" => esc_html__("Image", 'snsanton'),
				 //      "param_name" => "image" 
				 //    ),		
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("The product",'snsanton'),
						"param_name" => "product",
						"description" => "",
						"value" => $product_onsale,			
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Excerpt length",'snsanton'),
						"param_name" => "excerpt_lenght",
						"value" => "40"
					),
				$vc_add_css_animation,
				$sns_extra_class,
			)
	) );

	class WPBakeryShortCode_SNS_Single_Product extends WPBakeryShortCode {}
	vc_map( array(
			"name" => esc_html__("SNS Single Product",'snsanton'),
			"base" => "sns_single_product",
			"icon" => "sns_icon_single_product",
			"class" => "sns_single_product",
			"category" => esc_html__("SNS WooCommerce",'snsanton'),
			"description" => esc_html__( "Show a single product by ID or SKU", 'snsanton' ),
			"params" => array(
				array(
					'type' => 'autocomplete',
					'heading' => __( 'Select identificator', 'snsanton' ),
					'param_name' => 'id',
					'description' => __( 'Input product ID or product SKU or product title to see suggestions', 'snsanton' ),
				),
				array(
					'type' => 'hidden',
					// This will not show on render, but will be used when defining value for autocomplete
					'param_name' => 'sku',
				),
				array(
			      "type" => "attach_image",
			      "heading" => esc_html__("Product Image", 'snsanton'),
			      "param_name" => "product_image",
			      'description' => __( "If you don't sellect this option, It will be use default image of the product", "snsanton" ),
			    ),
				$vc_add_css_animation,
				$sns_extra_class,
			)
	) );

	// SNS Our Agency
	class WPBakeryShortCode_SNS_Our_Agency extends WPBakeryShortCode {
		public function category($tab, $tab_types, $cat_thumb_class){
			$cat = get_term_by('slug', $tab, 'product_cat');
			
				return array('name'=>str_replace(' ', '_', $tab),'title'=>$cat->name,'short_title'=>$cat->name, 'thumbnail' => $image, 'icon' => $icon);
		}
	}
	// Autocomplete product
    if ( class_exists('Vc_Vendor_Woocommerce') ){
        $agency_vcwoo = 'Vc_Vendor_Woocommerce';
        add_filter( 'vc_autocomplete_sns_our_agency_list_product_callback', array(&$agency_vcwoo, 'productIdAutocompleteSuggester',), 10, 1 ); // Get suggestion(find). Must return an array
        add_filter( 'vc_autocomplete_sns_our_agency_list_product_render', array(&$agency_vcwoo, 'productIdAutocompleteRender',), 10, 1 ); // Render exact product. Must return an array (label,value)
    }
	vc_map( array(
		"name" => esc_html__("SNS Our Agency",'snsanton'),
		"base" => "sns_our_agency",
		"class" => "sns_our_agency",
		"category" => esc_html__("Content",'snsanton'),
		"description" => esc_html__( "Our Agency",'snsanton' ),
		"params" => array(
			array(
		      "type" => "attach_image",
		      "heading" => esc_html__("Image", 'snsanton'),
		      "param_name" => "image" 
		    ),
		    array(
				"type" => "textfield",
				"heading" => esc_html__("Link for image",'snsanton'),
				"param_name" => "img_link",
				"value" => "#"
			),
		    array(
				"type" => "textfield",
				"heading" => esc_html__("Image title",'snsanton'),
				"param_name" => "img_title",
				"value" => ""
			),
		     array(
				"type" => "textfield",
				"heading" => esc_html__("Title",'snsanton'),
				"param_name" => "title",
				"value" => ""
			),

			 array(
		      	"type" => "textarea_html",
		      	"heading" => esc_html__("Short description", 'snsanton'),
		     	 "param_name" => "content",
		    ),
			 array(
				"type" => "textfield",
				"heading" => esc_html__("Sub Title",'snsanton'),
				"param_name" => "sub_title",
				"value" => ""
			),

			// array(
			// 	"type" => "sns_woo_products",
			// 	"class" => "",
			// 	"heading" => esc_html__("Select Products",'snsanton'),
			// 	"param_name" => "list_product",
			// 	"description" => "",
			// ),
			array(
				'type' => 'autocomplete',
				'heading' => __( 'Select Products', 'snsanton' ),
				'param_name' => 'list_product',
				'settings' => array(
					'multiple' => true,
					'sortable' => true,
					'unique_values' => true,
					// In UI show results except selected. NB! You should manually check values in backend
				),
				'save_always' => true,
				'description' => __( 'You can typing id or product name to input form.', 'snsanton' ),
			),
			
			$vc_add_css_animation,
			$sns_extra_class,
			
		)
	));

	// SNS select category
	class WPBakeryShortCode_SNS_Category extends WPBakeryShortCode {
		public function category($tab, $tab_types, $cat_thumb_class){
			$cat = get_term_by('slug', $tab, 'product_cat');
			
				return array('name'=>str_replace(' ', '_', $tab),'title'=>$cat->name,'short_title'=>$cat->name, 'thumbnail' => $image, 'icon' => $icon);
		}


		public function snsanton_getListTabTitle(){
			$this->atts = vc_map_get_attributes( $this->getShortcode(), $this->atts );
			$array_tab = array();
			if ( $this->atts['tab_types'] == 'category' ) :
				if( empty($this->atts['list_cat']) ) :
					$array_tab = $this->snsanton_getCats();
				else :
					$array_tab = explode(',', $this->atts['list_cat']);
				endif;
				//var_dump($array_tab);
			else :
				$array_tab = explode(',', $this->atts['list_orderby']);
			endif;
			foreach ($array_tab as $tab) {
				$list_tab[$tab] = $this->snsanton_tabTitle($tab, $this->atts['tab_types'], $this->atts['cat_thumbnail']);
			}
			return $list_tab;
		}

		
		public function snsanton_getCats(){
			$cats = get_terms('product_cat');
			$arr = array();
			foreach ($cats as $cat) {
				$arr[] = $cat->slug;
			}
			return $arr;
		}
	}

	vc_map( array(
		"name" => esc_html__("SNS Category",'snsanton'),
		"base" => "sns_category",
		"icon" => "sns_icon_sns_categoy",
		"class" => "sns_category",
		"category" => esc_html__("SNS WooCommerce",'snsanton'),
		"description" => esc_html__( "WooCommerce category",'snsanton' ),
		"params" => array(
			array(
		      "type" => "attach_image",
		      "heading" => esc_html__("Image 1", 'snsanton'),
		      "param_name" => "image1" 
		    ),
		    array(
		      "type" => "attach_image",
		      "heading" => esc_html__("Image", 'snsanton'),
		      "param_name" => "image" 
		    ),
		     array(
				"type" => "textfield",
				"heading" => esc_html__("Image title",'snsanton'),
				"param_name" => "img_title",
				"value" => ""
			),
			array(
				"type" => "dropdown",
				"value" => Array( 	
							"left" => "left" ,
							"right" => "right" 
				),
				"heading" => esc_html__("Image alignment", 'snsanton'),
				"param_name" => "image_alignment" 
			),
			
			array(
				"type" => "dropdown",
				"class" => "",
				"value" => $woocat_value,
				"heading" => esc_html__("Select Category",'snsanton'),
				"param_name" => "category",
				"description" => ""
			),
			array(
				"type" => "colorpicker",
				"value" => "",
				"heading" => esc_html__("Category Background", 'snsanton'),
				"param_name" => "bg_color"

		    ),
			array(
				"type" => "textfield",
				"heading" => esc_html__("Sub title",'snsanton'),
				"param_name" => "sub_title",
				"value" => ""
			),
			array(
				'type' => 'autocomplete',
				'heading' => __( 'Select identificator', 'snsanton' ),
				'param_name' => 'id',
				'description' => __( 'Input product ID or product SKU or product title to see suggestions', 'snsanton' ),
			),
			array(
				'type' => 'hidden',
				// This will not show on render, but will be used when defining value for autocomplete
				'param_name' => 'sku',
			),
			array(
				"type" => "textfield",
				"heading" => esc_html__("Label product",'snsanton'),
				"param_name" => "label_product",
				"value" => ""
			),
			array(
				"type" => "textarea",
				"class" => "",
				"heading" => esc_html__("Product excerpt",'snsanton'),
				"param_name" => "product_excerpt",
				"value" => "",
				"description" => esc_html__("Custom the description for the product.", 'snsanton'),
			),
			$vc_add_css_animation,
			$sns_extra_class,
			
		)
	));
}

// SNS Custom Box
class WPBakeryShortCode_SNS_Custom_Box extends WPBakeryShortCode {}
vc_map( array(
	"name"  => esc_html__("SNS Custom Box", 'snsanton'),
	"base" => "sns_custom_box",
	"show_settings_on_create" => true ,
	"is_container" => false ,
	"icon" => "vc_icon_snstheme",
	"class" => "vc_icon_snstheme",
	"content_element" => true ,
	"category" => esc_html__('Content', 'snsanton'),
	'description' => esc_html__( 'Box contain: icon, title, description', 'snsanton' ),
  //  "as_child" => array('only' => 'sns_featured_categories'), // Use only|except attributes to limit parent (separate multiple values with comma)
	"params" => array(		
	    array(
			"type" => "dropdown",
			'value' => array(
				esc_html__( 'Style 1', 'snsanton' ) => 'style1',
				esc_html__( 'Style 2', 'snsanton' ) => 'style2',
			),
			"heading" => esc_html__("Template", 'snsanton'),
			"param_name" => "box_template"

	    ),
	   
		array(
			'type' => 'dropdown',
			'heading' => esc_html__( 'Icon library', 'snsanton' ),
			'value' => array(
				esc_html__( 'Media', 'snsanton' ) => 'media',
				esc_html__( 'Font Awesome', 'snsanton' ) => 'fontawesome',
				esc_html__( 'Open Iconic', 'snsanton' ) => 'openiconic',
				esc_html__( 'Typicons', 'snsanton' ) => 'typicons',
				esc_html__( 'Entypo', 'snsanton' ) => 'entypo',
				esc_html__( 'Linecons', 'snsanton' ) => 'linecons',
			),
			'param_name' => 'icon_type',
			'description' => esc_html__( 'Select icon library.', 'snsanton' ),
		),
		array(
	      "type" => "attach_image",
	      "heading" => esc_html__("Image", 'snsanton'),
	      "param_name" => "icon_image",
	      'dependency' => array(
				'element' => 'icon_type',
				'value' => 'media',
			),
	    ),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'snsanton' ),
			'param_name' => 'icon_fontawesome',
			'value' => 'fa fa-adjust', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false,
				'iconsPerPage' => 4000,
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'fontawesome',
			),
			'description' => esc_html__( 'Select icon from library.', 'snsanton' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'snsanton' ),
			'param_name' => 'icon_openiconic',
			'value' => 'vc-oi vc-oi-dial', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'openiconic',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'openiconic',
			),
			'description' => esc_html__( 'Select icon from library.', 'snsanton' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'snsanton' ),
			'param_name' => 'icon_typicons',
			'value' => 'typcn typcn-adjust-brightness', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'typicons',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'typicons',
			),
			'description' => esc_html__( 'Select icon from library.', 'snsanton' ),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'snsanton' ),
			'param_name' => 'icon_entypo',
			'value' => 'entypo-icon entypo-icon-note', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'entypo',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'entypo',
			),
		),
		array(
			'type' => 'iconpicker',
			'heading' => esc_html__( 'Icon', 'snsanton' ),
			'param_name' => 'icon_linecons',
			'value' => 'vc_li vc_li-heart', // default value to backend editor admin_label
			'settings' => array(
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'type' => 'linecons',
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display
			),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => 'linecons',
			),
			'description' => esc_html__( 'Select icon from library.', 'snsanton' ),
		),
		array(
			"type" => "colorpicker",
			"value" => "",
			"heading" => esc_html__("Color for icon", 'snsanton'),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => array('linecons','fontawesome','entypo','typicons','openiconic'),
			),
			"param_name" => "icon_color"

	    ),
		array(
			"type" => "colorpicker",
			"value" => "",
			"heading" => esc_html__("Background Color for icon", 'snsanton'),
			"param_name" => "icon_bgcolor"

	    ),
	   
		array(
			"type" => "textfield",
			"heading" => esc_html__("Font size for icon", 'snsanton'),
			"param_name" => "icon_font_size" ,
			"value" => esc_html__("25px",'snsanton'),
			'dependency' => array(
				'element' => 'icon_type',
				'value' => array('linecons','fontawesome','entypo','typicons','openiconic'),
			),
			"description" => esc_html__("It's font-size for icon you sellected, example: 24px", 'snsanton')
		),

		array(
			"type" => "textfield",
			"heading" => esc_html__("Custom Link", 'snsanton'),
			"param_name" => "link" ,
			"description" => esc_html__("Enter the  link. Do't forget to include http:// ", 'snsanton'),
			"value" => esc_html__("http://", 'snsanton')
		),
		array(
			"type" => "dropdown",
			'value' => array(
				esc_html__( 'Left', 'snsanton' ) => 'left',
				esc_html__( 'Right', 'snsanton' ) => 'right',
				esc_html__( 'Center', 'snsanton' ) => 'center',
			),
			"heading" => esc_html__("Text align", 'snsanton'),
			"param_name" => "text_align"

	    ),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Title", 'snsanton'),
			"param_name" => "title",
			"value" => esc_html__("Your Title Here ...",'snsanton'),
			"admin_label" => true 
		),
		array(
			"type" => "colorpicker",
			"heading" => esc_html__("Title color", 'snsanton'),
			"param_name" => "title_color",
			"value" => "",
		),
		array(
			"type" => "textarea",
			"heading" => esc_html__("Description", 'snsanton'),
			"param_name" => "desc"
		),

		$vc_add_css_animation,
		$sns_extra_class,
	)
));

class WPBakeryShortCode_SNS_Latest_Posts extends WPBakeryShortCode {}

vc_map( array(
	"name" => esc_html__("SNS Latest Posts",'snsanton'),
	"base" => "sns_latest_posts",
	"icon" => "sns_icon_latestpost",
	"class" => "sns_latestpost",
	"category" => esc_html__("Content",'snsanton'),
	"description" => esc_html__( "Show latest posts", 'snsanton' ),
	"params" => array(
		array(
			"type" => "textfield",
			"class" => "",
			"heading" => esc_html__("Title",'snsanton'),
			"param_name" => "title",
			"value" =>  esc_html__("Latest News",'snsanton'),
			"admin_label" => true,
		),
		array(
			"type" => "dropdown",
			"class" => "",
			"heading" => esc_html__("Title Style",'snsanton'),
			"param_name" => "text_align",
			"value" => array(
				esc_html__("Style1",'snsanton') =>  'style1',
				esc_html__("Style2",'snsanton') =>  'style2',
				esc_html__("Style3",'snsanton') => 'style3',
			),
		),
		array(
			"type" => "dropdown",
			"heading" => esc_html__("Show date",'snsanton'),
			"param_name" => "show_date",
			"class" => "",
			"value" => array(
				esc_html__("Yes",'snsanton') => '1',
				esc_html__("No",'snsanton') =>  '2',
			),
		),
		array(
			"type" => "dropdown",
			"class" => "",		
			"value" => array(
				esc_html__("",'snsanton') => '',
				esc_html__("Yes",'snsanton') => '1',
				esc_html__("No",'snsanton') =>  '2',
			),
			"heading" => esc_html__("Show Author",'snsanton'),
			"param_name" => "show_author",
		),
		array(
			"type" => "dropdown",
			"class" => "",		
			"value" => array(
				esc_html__("",'snsanton') => '',
				esc_html__("Yes",'snsanton') => '1',
				esc_html__("No",'snsanton') =>  '2',
			),
			"heading" => esc_html__("Show Excerpt",'snsanton'),
			"param_name" => "show_excerpt",
		),
		array(
			"type" => "dropdown",
			"class" => "",		
			"value" => array(
				esc_html__("Yes",'snsanton') => '1',
				esc_html__("No",'snsanton') =>  '2',
			),
			"heading" => esc_html__("Show buton read more",'snsanton'),
			"param_name" => "show_readmore",
		),
		array(
			"type" => "textfield",
			"class" => "",
			"heading" => esc_html__("Posts number limit",'snsanton'),
			"param_name" => "number_limit",
			"value" => "12"
		),
		$vc_add_css_animation,
		$sns_extra_class,
	)
) );

class WPBakeryShortCode_SNS_Blog_Page extends WPBakeryShortCode {}

vc_map( array(
	"name" => esc_html__("SNS Blog Page",'snsanton'),
	"base" => "sns_blog_page",
	"icon" => "sns_icon_blogpage",
	"class" => "sns_blogpage",
	"category" => esc_html__("Content",'snsanton'),
	"description" => esc_html__( "To create blog page with some style", 'snsanton' ),
	"params" => array(
		array(
			"type" => "checkbox",
			"value" => $cat_value,
			"class" => "",
			"heading" => esc_html__("Categories",'snsanton'),
			"description" => esc_html__( "If you dont sellect category, the default is sellected all category", 'snsanton' ),
			"param_name" => "category"
		),
		array(
			"type" => "dropdown",
			"class" => "",
			"heading" => esc_html__("Blog Style",'snsanton'),
			"param_name" => "blog_type",
			"value" => array(
				esc_html__("Blog Layout 1",'snsanton') 	=> "",
				esc_html__("Blog Layout 2",'snsanton') 	=>  "layout2",
				esc_html__("Masonry",'snsanton')			=>  "masonry",
			),
			"description" => ""
		),
		array(
			"type" => "textfield",
			"class" => "",
			"heading" => esc_html__("Post per pages",'snsanton'),
			"param_name" => "posts_per_page",
			"value" => "6"
		),
		array(
			"type" => "textfield",
			"class" => "",
			"heading" => esc_html__("Excerpt Length",'snsanton'),
			"param_name" => "excerpt_length",
			"value" => "35"
		),

		array(
			"type" => "dropdown",
			"class" => "",
			"heading" => esc_html__("Enable Read More Button",'snsanton'),
			"param_name" => "show_readmore",
			"value" => array(
				esc_html__("Yes",'snsanton') => '1',
				esc_html__("No",'snsanton') =>  '2',
			),
			'description' => esc_html__('Choose Type of navigation.','snsanton')
		),
		array(
			"type" => "dropdown",
			"class" => "",
			"heading" => esc_html__("Page Navigation",'snsanton'),
			"param_name" => "pagination",
			"value" => array(
				esc_html__("Default",'snsanton') => 'def',
				esc_html__("Ajax",'snsanton') =>  'ajax'
			),
			'description' => esc_html__('Choose Type of navigation.','snsanton')
		),
		
		$vc_add_css_animation,
		$sns_extra_class,
	)
) );

class WPBakeryShortCode_SNS_Member extends WPBakeryShortCode {}

vc_map( array(
	"name" => esc_html__("SNS Member",'snsanton'),
	"base" => "sns_member",
	"icon" => "sns_icon_member",
	"class" => "sns_member",
	"category" => esc_html__("Content",'snsanton'),
	"description" => esc_html__( "Display team member", 'snsanton' ),
	"params" => array(
		array(
	      "type" => "attach_image",
	      "heading" => esc_html__("Avartar", 'snsanton'),
	      "param_name" => "avartar" 
	    ),
	    array(
			"type" => "dropdown",
			"heading" => esc_html__("Avartar style",'snsanton'),
			"param_name" => "avartar_style",
			"value" => array(
				esc_html__("Default",'snsanton') => "",
				esc_html__("Rounded",'snsanton') =>  "rounded",
				esc_html__("Circle",'snsanton') =>  "circle"
			),
			"description" => ""
		),
		array(
			'type' => 'vc_link',
			'heading' => esc_html__( 'Link to member', 'snsanton' ),
			'param_name' => 'link',
		),
	    array(
	      "type" => "textfield",
	      "heading" => esc_html__("Member name", 'snsanton'),
	      "param_name" => "name",
		  "admin_label" => true
	    ),
	    array(
	      "type" => "textfield",
	      "heading" => esc_html__("Member role", 'snsanton'),
	      "param_name" => "role",
		  "admin_label" => true
	    ),
	    array(
	      "type" => "textarea_html",
	      "heading" => esc_html__("Short description", 'snsanton'),
	      "param_name" => "content",
	    ),
	   //  array(
	   //    "type" => "checkbox",
	   //    "heading" => esc_html__("Social Links", 'snsanton'),
	   //    "param_name" => "social_links",
		  // "value" => Array('Twitter'=>'twitter' ,'Facebook'=>'facebook','Linkedin'=>'linkedin','Youtube'=>'youtube','Google plus'=>'google','Behance'=>'behance','Dribbble'=>'dribbble','Pinterest'=>'pinterest')
	   //  ),
		array(
	      "type" => "textfield",
	      "heading" => esc_html__("Twitter link", 'snsanton'),
	      "param_name" => "twitter",
		  //"dependency" => Array('element' => "social_links", 'value' => 'twitter')
	    ),
		array(
	      "type" => "textfield",
	      "heading" => esc_html__("Facebook link", 'snsanton'),
	      "param_name" => "facebook",
		  //"dependency" => Array('element' => "social_links", 'value' => 'facebook')
	    ),
		array(
	      "type" => "textfield",
	      "heading" => esc_html__("youtube link", 'snsanton'),
	      "param_name" => "youtube",
		  //"dependency" => Array('element' => "social_links", 'value' => 'youtube')
	    ),
		array(
	      "type" => "textfield",
	      "heading" => esc_html__("google link", 'snsanton'),
	      "param_name" => "google",
		  //"dependency" => Array('element' => "social_links", 'value' => 'google')
	    ),
		array(
	      "type" => "textfield",
	      "heading" => esc_html__("pinterest link", 'snsanton'),
	      "param_name" => "pinterest",
		  //"dependency" => Array('element' => "social_links", 'value' => 'pinterest')
	    ),
	    $vc_add_css_animation,
	    $sns_extra_class,
	)
) );

?>