<?php
/**
 * Single Product Image
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/product-image.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 7.8.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
wp_enqueue_script('owlcarousel');

global $post, $product;
$show_product_sidebar = get_post_meta( get_the_ID(), 'snsanton_product_sidebar', true );
if($show_product_sidebar == '') $show_product_sidebar = snsanton_themeoption('single_product_sidebar');

$columns           = apply_filters( 'woocommerce_product_thumbnails_columns', 4 );
$post_thumbnail_id = get_post_thumbnail_id( $post->ID );
$full_size_image   = wp_get_attachment_image_src( $post_thumbnail_id, 'full' );
$shop_single_size_image       = wp_get_attachment_image_src( $post_thumbnail_id, 'shop_single' );
$image_title       = get_post_field( 'post_excerpt', $post_thumbnail_id );
$placeholder       = has_post_thumbnail() ? 'with-images' : 'without-images';
$wrapper_classes   = apply_filters( 'woocommerce_single_product_image_gallery_classes', array(
	'woocommerce-product-gallery',
	'woocommerce-product-gallery--' . $placeholder,
	'woocommerce-product-gallery--columns-' . absint( $columns ),
	'images',
) );
?>
<div class="images">
	<?php
	$attributes = array(
		'id'					  => 'sp_mainimage',
		'title'                   => $image_title,
		'data-src'                => $full_size_image[0],
		'data-large_image'        => $full_size_image[0],
		'data-large_image_width'  => $full_size_image[1],
		'data-large_image_height' => $full_size_image[2],
	);
	if ( has_post_thumbnail() ) {
		$attachment_count = count( $product->get_gallery_image_ids() );
		if ( $attachment_count > 0 ) {
			$gallery = '[product-gallery]';
		} else {
			$gallery = '';
		}
		
		$html  = '<div class="mainimage-wrap">';
		$html .= '<div data-thumb="' . get_the_post_thumbnail_url( $post->ID, 'shop_catalog' ) . '" class="woocommerce-product-gallery__image"><a class="woocommerce-main-image zoom" data-rel="prettyPhoto' . $gallery . '" href="' . esc_url( $full_size_image[0] ) . '">';
		$html .= get_the_post_thumbnail( $post->ID, 'shop_single', $attributes );
		$html .= '</a></div>';
		$html .= '<div class="popup-btn-wrap">
					<a class="btn sns-btn-popup" data-rel="prettyPhoto[product-gallery]" href="#" data-toggle="tooltip" data-original-title="'.esc_html__( 'Zoom','snsanton' ).'"></a>';
		if(  get_post_meta( $post->ID, 'snsanton_product_video', true ) ):
		$html .= '<a class="btn sns-btn-popupvideo" data-rel="prettyPhoto[product-gallery]" href="'.get_post_meta( $post->ID, 'snsanton_product_video', true ).'" data-toggle="tooltip" data-original-title="'.esc_html__( 'Video','snsanton' ).'"></a>';
		endif;
		$html .= '</div>';
		$html .= '</div>';
	} else {
		$html  = '<div class="woocommerce-product-gallery__image--placeholder">';
		$html .= sprintf( '<img src="%s" alt="%s" class="wp-post-image" />', esc_url( wc_placeholder_img_src() ), esc_html__( 'Awaiting product image', 'snsanton' ) );
		$html .= '</div>';
	}
	echo apply_filters( 'woocommerce_single_product_image_thumbnail_html', $html, get_post_thumbnail_id( $post->ID ) );
	?>
	<div class="sns-thumbnails handle-preload">
		<div id="sns_thumbs" class="thumbnails">
			<?php if (  $show_product_sidebar  != '1') : ?>
			<a href="#" class="buttons prev"></a>
			<div class="viewport">
			<div class="overview">
			<?php endif; ?>
			<?php
			if ( has_post_thumbnail() ) {
				$image_thumb       = wp_get_attachment_image( get_post_thumbnail_id(), 'shop_catalog' );
				echo( '<div data-thumb="' . get_the_post_thumbnail_url( get_post_thumbnail_id(), 'shop_catalog' ) . '" class="woocommerce-product-gallery__image"><a href="'.$shop_single_size_image[0].'" class="elevatezoom-gallery zoom active cloned" title="'. $image_title .'" data-image="'.$full_size_image[0].'" data-zoom-image="'.$shop_single_size_image[0].'" data-rel="prettyPhoto[product-gallery]">'.$image_thumb.'</a></div>' );
			}
			do_action( 'woocommerce_product_thumbnails' ); 
			?>
			<?php if (  $show_product_sidebar  != '1') : ?>
			</div>
			</div>
			<a href="#" class="buttons next"></a>
			<?php endif; ?>
		</div>
		<?php if (  $show_product_sidebar  == '1') : ?>
		<div class="navslider">
			<span class="prev"><i class="fa fa-angle-left" aria-hidden="true"></i></span>
			<span class="next"><i class="fa fa-angle-right" aria-hidden="true"></i></span>
		</div>
	<?php endif; ?>
	</div>
	<script type="text/javascript">
		jQuery(document).ready(function(){
			// Lightbox
			<?php if (  $show_product_sidebar  != '1') { ?>
				jQuery('.sns-thumbnails').append('<div id="sns_thumbs_clone" style="display:none">'+jQuery('.sns-thumbnails #sns_thumbs .overview').html()+'</div>');
			<?php } else { ?>
				jQuery('.sns-thumbnails').append('<div id="sns_thumbs_clone" style="display:none">'+jQuery('.sns-thumbnails #sns_thumbs').html()+'</div>');
			<?php } ?>
			elements = "#sns_thumbs_clone a.zoom:not(.cloned)";
			if( jQuery('.sns_main_products .sns-btn-popup').length && jQuery('.sns_main_products a.woocommerce-main-image').length ){
				jQuery('.sns_main_products .sns-btn-popup').attr('href', jQuery('.sns_main_products a.woocommerce-main-image').attr('href') );
				elements = elements + ", .sns_main_products .sns-btn-popup";
				jQuery('.sns_main_products a.woocommerce-main-image').click(function(){
					return false;
				});
			}
			<?php if(  get_post_meta( $post->ID, 'snsanton_product_video', true ) ) : ?>
			elements = elements + ", .sns_main_products .sns-btn-popupvideo";
			<?php endif; ?>
			//if (typeof prettyPhoto === 'function') {
			jQuery(elements).prettyPhoto({
				hook: 'data-rel',
				social_tools: false,
				theme: 'pp_woocommerce',
				horizontal_padding: 20,
				opacity: 0.8,
				deeplinking: false
			});
			//}
			<?php if ( has_post_thumbnail() ) {?>
			jQuery('.col-lg-12 .col-lg-12 #sns_thumbs .viewport').css('height', jQuery('.col-lg-12 .col-lg-12 #sns_thumbs .overview').height());
			jQuery('.col-lg-12 .col-lg-12 #sns_thumbs').tinycarousel({
                axis   : "y",
                intervalTime:   800
            });
            <?php }else { ?>
            	jQuery('.col-lg-12 .col-lg-12 .sns-thumbnails').hide();
            <?php } ?>
			// Carousel Gallery
			<?php if ( has_post_thumbnail() && $attachment_count >= 2) : ?>
			jQuery('.col-lg-9 .sns-thumbnails #sns_thumbs').owlCarousel({
				items: 3,
				loop:true,
	            dots: false,
	            onInitialized: callback,
	            slideSpeed : 800
			});
			function callback(event) {
	   			if(this._items.length > this.options.items){
			        jQuery('.sns-thumbnails .navslider').show();
			    }else{
			        jQuery('.sns-thumbnails .navslider').hide();
			    }
			    
			}
			jQuery('.sns-thumbnails .prev').on('click', function(e){
				e.preventDefault();
				jQuery('.sns-thumbnails .thumbnails').trigger('prev.owl.carousel');
			});
			jQuery('.sns-thumbnails .next').on('click', function(e){
				e.preventDefault();
				jQuery('.sns-thumbnails .thumbnails').trigger('next.owl.carousel');
			});
			<?php endif; ?>
			<?php if ( !snsanton_themeoption('woo_usecloudzoom') ) : ?>
				jQuery('#sns_thumbs .zoom').bind('touchstart click', function(e) {

					jQuery('#sns_thumbs .zoom').removeClass('active');
					jQuery(this).addClass('active');
					//stop any link on the a tag from working
					e.preventDefault();

					var img_to = jQuery(this).data("image");
					if ( jQuery('.sns_main_products .sns-btn-popup').length ){
						jQuery('.sns_main_products .sns-btn-popup').attr('href', img_to);
					}

					setTimeout( function() {
						jQuery('#sp_mainimage').attr('src', img_to).attr('srcset', '');
					}, 600);

					return false;
				});
			<?php endif; ?>
		});
		<?php if ( snsanton_themeoption('woo_usecloudzoom') ) : 
			$woo_zoomtype = get_post_meta( get_the_id(), 'snsanton_woo_zoomtype', true );
			if($woo_zoomtype == '')
				$woo_zoomtype = snsanton_themeoption('woo_zoomtype');
		?>
		
		jQuery(window).load(function(){
			jQuery('#sp_mainimage').elevateZoom({
				zoomType : "<?php echo esc_js($woo_zoomtype); ?>",
				<?php if ( $woo_zoomtype == 'lens' ): ?>
				lensShape : "round", lensSize : 200,
				<?php endif; ?>
				<?php if ( $woo_zoomtype == 'inner' ): ?>
				cursor: "crosshair",
				<?php endif; ?>
				zoomWindowWidth: 400,
				zoomWindowHeight: 400,
				zoomWindowOffetx: 1,
				zoomWindowOffety: -0.5,
				gallery:'sns_thumbs',
				galleryActiveClass: 'active',
				imageCrossfade: true,
				responsive:true
				
			});
		});
		<?php endif; ?>
	</script>
</div>
