<?php
/**
 * Related Products
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/related.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see         https://docs.woocommerce.com/document/template-structure/
 * @package     WooCommerce/Templates
 * @version     3.9.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product, $woocommerce_loop;

if ( empty( $product ) || ! $product->exists() ) {
	return;
}
if ( snsanton_themeoption('woo_related_num') && snsanton_themeoption('woo_related_num') > 0 ){
	$woo_related_num = snsanton_themeoption('woo_related_num');
}else{
	$woo_related_num = $posts_per_page;
}
$related = wc_get_related_products($product->get_id());

if ( sizeof( $related ) == 0 ) return;

$args = apply_filters( 'woocommerce_related_products_args', array(
	'post_type'            => 'product',
	'ignore_sticky_posts'  => 1,
	'no_found_rows'        => 1,
	'posts_per_page'       => $woo_related_num,
	'orderby'              => $orderby,
	'post__in'             => $related,
	'post__not_in'         => array( $product->get_id() )
) );

$products = new WP_Query( $args );

$woocommerce_loop['columns'] = $columns;

if ( $products->have_posts() ) : 
	wp_enqueue_script('owlcarousel');
?>

<?php 
$the_sidebar = wp_get_sidebars_widgets();
$show_product_sidebar = get_post_meta( get_the_ID(), 'snsanton_product_sidebar', true );
if($show_product_sidebar == '') $show_product_sidebar = snsanton_themeoption('single_product_sidebar');
$woo_related_num_1200 = 4;
if (  $show_product_sidebar == '1' ) :
	$woo_related_num_1200 = 4;
endif;
?>
	<div class="related products">
		<div class="related-content">
			<div class="sns_products_heading">
				<h2 class="wpb_heading"><span><?php _e( 'Related Products', 'snsanton' ); ?></span></h2>
				<div class="navslider">
					<span class="prev"></span>
					<span class="next"></span>
				</div>
			</div>
			<?php woocommerce_product_loop_start(); ?>

				<?php
				while ( $products->have_posts() ) : $products->the_post(); ?>

					<?php wc_get_template_part( 'content', 'product' ); ?>

				<?php endwhile; // end of the loop. ?>

			<?php woocommerce_product_loop_end(); ?>
		</div>
		<?php if ($posts_per_page >= 2): ?>
		<script type="text/javascript">
			jQuery(document).ready(function(){
				
				jQuery('.related ul').owlCarousel({
					items: 4,
					responsive : {
					    0 : { items: 1 },
					    480 : { items:  2},
					    768 : { items:  3},
					    992 : { items:  3 },
					    1200 : { items: <?php echo esc_js($woo_related_num_1200); ?> }
					},
					loop:false,
		            dots: false,
				    autoplay: false,
		            onInitialized: callback,
		            slideSpeed : 800
				});
				function callback(event) {
		   			if(this._items.length > this.options.items){
				        jQuery('.related .navslider').show();
				        jQuery('.related').addClass('has-nav');
				    }else{
				        jQuery('.related .navslider').hide();
				        jQuery('.related').removeClass('has-nav');
				    }
				}
				jQuery('.related .navslider .prev').on('click', function(e){
					e.preventDefault();
					jQuery('.related ul').trigger('prev.owl.carousel');
				});
				jQuery('.related .navslider .next').on('click', function(e){
					e.preventDefault();
					jQuery('.related ul').trigger('next.owl.carousel');
				});
			});
		</script>
	<?php endif ?>
	</div>

<?php endif;

wp_reset_postdata();
