<?php
/**
 * Single Product Up-Sells
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/up-sells.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.0.0
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product, $woocommerce_loop;

$upsells = $product->get_upsell_ids();

if ( sizeof( $upsells ) == 0 ) {
	return;
}

$meta_query = WC()->query->get_meta_query();
if( empty($posts_per_page) ) $posts_per_page = -1; 

$args = array(
	'post_type'           => 'product',
	'ignore_sticky_posts' => 1,
	'no_found_rows'       => 1,
	'posts_per_page'      => $posts_per_page,
	'orderby'             => $orderby,
	'post__in'            => $upsells,
	'post__not_in'        => array( $product->get_id() ),
	'meta_query'          => $meta_query
);

$products = new WP_Query( $args );

$woocommerce_loop['columns'] = $columns;

if ( $products->have_posts() ) :
	wp_enqueue_script('owlcarousel');
	?>

<?php
$the_sidebar = wp_get_sidebars_widgets();
$show_product_sidebar = get_post_meta( get_the_ID(), 'snsanton_product_sidebar', true );
if($show_product_sidebar == '') $show_product_sidebar = snsanton_themeoption('single_product_sidebar');
$upsell_related_num_1200 = 4;
if (  $show_product_sidebar == '1' ) :
	$upsell_related_num_1200 = 4;
endif;
?>

	<div class="upsells products">
		<div class="upsells-content">
			<div class="sns_products_heading">
				<h2 class="wpb_heading"><span><?php esc_html_e( 'Upsell products', 'snsanton' ) ?></span></h2>
				<div class="navslider">
					<span class="prev"></span>
					<span class="next"></span>
				</div>
			</div>
			<?php woocommerce_product_loop_start(); ?>

			<?php while ( $products->have_posts() ) : $products->the_post(); ?>

				<?php wc_get_template_part( 'content', 'product' ); ?>

			<?php endwhile; // end of the loop. ?>
			<?php woocommerce_product_loop_end(); ?>
		</div>
		<script type="text/javascript">
			jQuery(document).ready(function(){
				jQuery('.upsells ul').owlCarousel({
					items: 4,
					responsive : {
					    0 : { items: 1 },
					    480 : { items:  2},
					    768 : { items:  3},
					    992 : { items:  3 },
					    1200 : { items: <?php echo esc_js($upsell_related_num_1200); ?> }
					},
					loop:false,
		            dots: false,
		            // animateOut: 'flipInY',
				    //animateIn: 'pulse',
				    autoplay: false,
		            onInitialized: callback,
		            slideSpeed : 800
				});
				function callback(event) {
		   			if(this._items.length > this.options.items){
				        //jQuery('.upsells .navslider').show();
				        jQuery('.upsells').addClass('has-nav');
				    }else{
				        //jQuery('.upsells .navslider').hide();
				        jQuery('.upsells').removeClass('has-nav');
				    }
				}
				jQuery('.upsells .navslider .prev').on('click', function(e){
					e.preventDefault();
					jQuery('.upsells ul').trigger('prev.owl.carousel');
				});
				jQuery('.upsells .navslider .next').on('click', function(e){
					e.preventDefault();
					jQuery('.upsells ul').trigger('next.owl.carousel');
				});


				
			});
		</script>
	</div>

<?php endif;

wp_reset_postdata();
